##############################
#第一の試練メイン実行
##############################

#初期準備
execute if score #setman stage matches 0 run function suiryu_ordeal:stage/1/first

#スコア増加
scoreboard players add @e[tag=kairu] skill1 1
scoreboard players add @e[tag=kairu] skill2 1


##############################
#ダメージ計算
##############################

#体力検知
execute as @e[tag=boss] store result score @s hp run data get entity @s Health

#ダメージ量検知
execute as @e[tag=boss] run scoreboard players operation @s dead -= @s hp

#アクアフィールドによる防御力低下
execute as @e[tag=kairu,tag=defencedown] run scoreboard players operation @s dead *= @s healthboost
execute as @e[tag=kairu,tag=defencedown] run scoreboard players operation @s dead /= @s attackboost
execute as @e[tag=kairu,tag=defencedown] run scoreboard players add @s speedboost 1
execute as @e[tag=kairu,tag=defencedown,scores={speedboost=600..}] run tag @s remove defencedown


#体力計算
execute as @e[tag=boss,scores={dead=1..}] run scoreboard players operation @s dummyhp -= @s dead
execute as @e[tag=boss,scores={dead=1..}] run data merge entity @s {Health:1024f}
scoreboard players set @e[tag=boss,limit=1] dead 1024
execute as @e[tag=boss] store result bossbar suiryu:boss value run scoreboard players get @s dummyhp
execute as @e[tag=boss,tag=kairu2,scores={dummyhp=..0}] run scoreboard players remove #stageman skill2 1
execute as @e[tag=boss,tag=kairu2,scores={dummyhp=..0}] run data merge entity @s {NoAI:0b,HandItems:[{id:"minecraft:diamond_axe",Count:1b,tag:{display:{Name:"{\"text\":\"氷勇斧フロストアックス\",\"color\":\"aqua\",\"italic\":false}",Lore:["§r攻撃時に3秒間攻撃力上昇"]}}},{}],HandDropChances:[-327.67F,0.85F],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F],ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{display:{color:4791551}}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:16777215}}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:24319}}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"98eb571e-d5a9-4fd2-b9af-1d219fc7f3e2",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvYjc0YzdiOGE3MjdlMjk3YTIwODBiNDI5NTg5ZWY0M2RkMGYyYmI2YjAxNzJmOTc1YTdiYTQ5ZGUxMWRlNGFiZCJ9fX0="}]}}}}]}
execute as @e[tag=boss,tag=kairu2,scores={dummyhp=..0}] run effect clear @s minecraft:invisibility
execute as @e[tag=boss,tag=kairu2,scores={dummyhp=..0}] run kill @s



##############################
#第一段階
##############################


#体力50以下で第二段階へ
execute as @e[tag=kairu1,limit=1,tag=!hp50,tag=hp75,tag=!skill,scores={dummyhp=..50}] run tag @s add 2nd
execute as @e[tag=2nd,limit=1,tag=kairu1] run function suiryu_ordeal:stage/1/2nd



##############################
#第二段階
##############################

#体力50以下で1度のみ真・魔神破斧撃
execute as @e[tag=kairu2,limit=1,tag=!skill,tag=!breakaxeneo,scores={dummyhp=..50},nbt={OnGround:1b}] run tag @s add breakaxeneo
execute as @e[tag=breakaxeneo,tag=!sp50,limit=1] run function suiryu_ordeal:stage/1/breakaxeneo


#体力25以下で1度のみアクアプロテクション
execute as @e[tag=kairu2,limit=1,tag=!skill,tag=!aquaprotection,scores={dummyhp=..25},nbt={OnGround:1b}] run tag @s add aquaprotection
execute as @e[tag=aquaprotection,tag=!sp25,limit=1] run function suiryu_ordeal:stage/1/aquaprotection

execute if entity @e[tag=regeneration,limit=1] run scoreboard players add @e[tag=kairu,limit=1] skill3 1
execute if entity @e[tag=regeneration,limit=1] run scoreboard players add @e[tag=kairu,limit=1] regeneration 1
execute if score @e[tag=regeneration,limit=1] skill3 matches 20.. run scoreboard players add @e[tag=kairu,limit=1] dummyhp 2
execute if score @e[tag=regeneration,limit=1] skill3 matches 20.. run scoreboard players set @e[tag=kairu,limit=1] skill3 0
execute if score @e[tag=regeneration,limit=1] regeneration matches 600.. run tag @e[tag=kairu,limit=1] remove regeneration


##############################
#共通
##############################


#50秒毎にフロストフィールド
execute as @e[tag=kairu,limit=1,tag=!skill,tag=!frostfield,scores={skill1=1000..},nbt={OnGround:1b}] run tag @s add frostfield
execute as @e[tag=frostfield,limit=1] run function suiryu_ordeal:stage/1/frostfield



#第一段階で体力75以下で1度のみアクアフィールド
#第二段階で体力75/50/25で1度のみアクアフィールド
execute as @e[tag=kairu,limit=1,tag=!hp75,tag=!skill,tag=!aquafield,scores={dummyhp=..75},nbt={OnGround:1b}] run tag @s add aquafield
execute as @e[tag=kairu,limit=1,tag=!hp50,tag=hp75,tag=!skill,tag=!aquafield,scores={dummyhp=..50},nbt={OnGround:1b}] run tag @s add aquafield
execute as @e[tag=kairu,limit=1,tag=!hp25,tag=hp50,tag=!skill,tag=!aquafield,scores={dummyhp=..25},nbt={OnGround:1b}] run tag @s add aquafield
execute as @e[tag=aquafield,limit=1] run function suiryu_ordeal:stage/1/aquafield











