##############################
#第十の試練メイン実行
##############################

#初期準備
execute if score #setman stage matches 0 run function suiryu_ordeal:stage/10/first

#スコア増加
scoreboard players add @e[tag=sekino,limit=1] skill1 1
scoreboard players add @e[tag=sekino,limit=1] skill2 1
scoreboard players add @e[tag=sekino,limit=1] skill3 1
scoreboard players add @e[tag=sekino,limit=1] skill4 1
scoreboard players add @e[tag=asuna,limit=1] skill1 1
scoreboard players add @e[tag=tori,limit=1] skill1 1
scoreboard players add @e[tag=tori,limit=1] skill2 1
scoreboard players add @e[tag=regene] healthboost 1
scoreboard players add @e[tag=regene,tag=!hp500] attackboost 1
scoreboard players add @e[tag=marie,limit=1] skill1 1
scoreboard players add @e[tag=marie,limit=1] skill2 1
scoreboard players add @e[tag=fureia,limit=1] skill1 1
scoreboard players add @e[tag=fureia,limit=1] skill2 1
scoreboard players add @e[tag=homura,limit=1] skill1 1
scoreboard players add @e[tag=homura,limit=1] skill2 1

effect give @e[tag=boss] minecraft:fire_resistance 30 0 true

#リレイズエフェクト
execute positioned as @e[tag=reraise,tag=!tori] run particle minecraft:instant_effect ~ ~2 ~ 0 0 0 0 1 force
execute positioned as @e[tag=reraise,tag=tori] run particle minecraft:instant_effect ~ ~0.8 ~ 0 0 0 0 1 force


##############################
#ダメージ計算
##############################

#体力検知
execute as @e[tag=boss] store result score @s hp run data get entity @s Health

#ダメージ量検知
execute as @e[tag=boss] run scoreboard players operation @s dead -= @s hp
execute as @e[tag=sekino3,tag=!blaze] run scoreboard players operation @s skill5 += @s dead


#体力計算
execute as @e[tag=boss,scores={dead=1..}] run scoreboard players operation @s dummyhp -= @s dead
execute as @e[tag=boss,scores={dead=1..}] run data merge entity @s {Health:1024f}
scoreboard players set @e[tag=boss] dead 1024
execute as @e[tag=sekino,limit=1] store result bossbar suiryu:boss value run scoreboard players get @s dummyhp
execute as @e[tag=asuna,limit=1] store result bossbar suiryu:boss1 value run scoreboard players get @s dummyhp
execute as @e[tag=tori,limit=1] store result bossbar suiryu:boss3 value run scoreboard players get @s dummyhp
execute as @e[tag=barado,limit=1] store result bossbar suiryu:boss2 value run scoreboard players get @s dummyhp
execute as @e[tag=marie,limit=1] store result bossbar suiryu:boss4 value run scoreboard players get @s dummyhp
execute as @e[tag=fureia,limit=1] store result bossbar suiryu:boss5 value run scoreboard players get @s dummyhp
execute as @e[tag=homura,limit=1] store result bossbar suiryu:boss6 value run scoreboard players get @s dummyhp
execute as @e[tag=boss,tag=reraise,tag=!sekino1,tag=!sekino2,scores={dummyhp=..0}] positioned as @s run function suiryu_ordeal:stage/10/reraise
execute as @e[tag=sekino3,limit=1,scores={dummyhp=..0}] run bossbar set suiryu:boss visible false
execute as @e[tag=asuna,limit=1,scores={dummyhp=..0}] run bossbar set suiryu:boss1 visible false
execute as @e[tag=tori,limit=1,scores={dummyhp=..0}] run bossbar set suiryu:boss3 visible false
execute as @e[tag=barado,limit=1,scores={dummyhp=..0}] run bossbar set suiryu:boss2 visible false
execute as @e[tag=marie,limit=1,scores={dummyhp=..0}] run bossbar set suiryu:boss4 visible false
execute as @e[tag=fureia,limit=1,scores={dummyhp=..0}] run bossbar set suiryu:boss5 visible false
execute as @e[tag=homura,limit=1,scores={dummyhp=..0}] run bossbar set suiryu:boss6 visible false
execute as @e[tag=sekino3,scores={dummyhp=..0},tag=!reraise] run data merge entity @s {NoAI:0b,HandItems:[{id:"minecraft:diamond_sword",Count:1b,tag:{display:{Name:"{\"text\":\"炎聖剣イグニート\",\"color\":\"red\",\"italic\":false}"},Enchantments:[{id:"minecraft:fire_aspect",lvl:10}]}},{}],HandDropChances:[-327.67F,0.85F],ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{display:{color:8732187},Enchantments:[{id:"minecraft:feather_falling",lvl:1}],AttributeModifiers:[{AttributeName:"generic.movementSpeed",Name:"generic.movementSpeed",Amount:0.15,Operation:1,UUIDLeast:321277,UUIDMost:791854,Slot:"feet"}]}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:8716288},Enchantments:[{id:"minecraft:protection",lvl:1}]}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:16711680},Enchantments:[{id:"minecraft:fire_protection",lvl:100}]}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"fb44ae6b-192e-4975-a152-2a953a6c73c9",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvNGNiYzI0NzNiNDc3OWJlZGIyN2I1ZDRiYjRiNTVhNGUxMzYwMjBiN2JmY2QyNmRjZmUxM2U2ZjAwMDcwZDUwZSJ9fX0="}]}}}}],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F]}
execute as @e[tag=asuna,scores={dummyhp=..0},tag=!reraise] run data merge entity @s {NoAI:0b,ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{display:{color:0},Enchantments:[{id:"minecraft:protection",lvl:1}],AttributeModifiers:[{AttributeName:"generic.movementSpeed",Name:"generic.movementSpeed",Amount:0.15,Operation:1,UUIDLeast:321277,UUIDMost:791854,Slot:"feet"}]}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:0},Enchantments:[{id:"minecraft:protection",lvl:1}]}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:655360},Enchantments:[{id:"minecraft:fire_protection",lvl:100}]}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"b1ff9c66-e92f-49ec-ba8c-f10ef6c4c6bd",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvNjAyYzk0ZTEyMDljYWRhY2M3NzZhYjY3OWZlNTE1OTAzMDk4ZjliMjYyZTBhMGY5OGUyNDMyNTMyNzQxNSJ9fX0="}]}}}}],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F]}
execute as @e[tag=marie,scores={dummyhp=..0},tag=!reraise] run data merge entity @s {NoAI:0b,ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{display:{color:16777215},AttributeModifiers:[{AttributeName:"generic.movementSpeed",Name:"generic.movementSpeed",Amount:0.3,Operation:1,UUIDLeast:321277,UUIDMost:791854,Slot:"feet"}]}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:16734658}}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:16715069}}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"37f2b32b-e5e7-4eb3-b036-0a239b4408b6",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvOTIzZmFmNThhZmQ2NzVhM2RkOTg3YTA5ZmEzZTc0NTNhYjI5ZWRkNmFkYmJlZWQ3YzQ4MzM4NjY4YjgyOGUifX19"}]}}}}],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F]}
execute as @e[tag=fureia,scores={dummyhp=..0},tag=!reraise] run data merge entity @s {NoAI:0b,ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{display:{color:16777215},AttributeModifiers:[{AttributeName:"generic.movementSpeed",Name:"generic.movementSpeed",Amount:-0.5,Operation:1,UUIDLeast:328976,UUIDMost:870640,Slot:"feet"}]}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:16777215}}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:16777215}}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"5c615e2b-d209-4776-87f9-45759c521d63",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvZWE0YTU1YzQ3MWI3NzcxY2M5MmUwMTQxMmU2ZGI4YmNlNjA3MzQ1ODgxNGE3YTY0Y2I3ZDBlY2Q4NzE5MDQ2In19fQ=="}]}}}}],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F]}
execute as @e[tag=homura,scores={dummyhp=..0},tag=!reraise] run data merge entity @s {NoAI:0b,HandItems:[{id:"minecraft:iron_sword",Count:1b,tag:{Enchantments:[{id:"minecraft:fire_aspect",lvl:10}]}},{}],HandDropChances:[-327.67F,0.85F],ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{display:{color:16711680}}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:16711680}}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:16711680}}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"69a4ed90-c7d1-4236-9f39-b8fb6e599c70",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvYTU5NTNkNjMxMjlmNTIwNWJjZGE5NmM5MWMwNzBjYjFkMzlkMTU1NWQ1ZGZjNDM4MThkNzM3ODg3YzNkMSJ9fX0="}]}}}}],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F]}
execute as @e[tag=sekino3,scores={dummyhp=..0},tag=!reraise] run kill @e[tag=sekinoarmorstand]
execute as @e[tag=asuna,scores={dummyhp=..0},tag=!reraise] run kill @e[tag=asunaarmorstand]
execute as @e[tag=marie,scores={dummyhp=..0},tag=!reraise] run kill @e[tag=mariearmorstand]
execute as @e[tag=fureia,scores={dummyhp=..0},tag=!reraise] run kill @e[tag=fureiaarmorstand]
execute as @e[tag=homura,scores={dummyhp=..0},tag=!reraise] run kill @e[tag=homuraarmorstand]
execute as @e[tag=boss,tag=!sekino1,tag=!sekino2,scores={dummyhp=..0},tag=!reraise] run scoreboard players remove #stageman skill2 1
execute as @e[tag=boss,tag=!sekino1,tag=!sekino2,scores={dummyhp=..0},tag=!reraise] run effect clear @s minecraft:invisibility
execute as @e[tag=tori,limit=1,scores={dummyhp=..0},tag=!reraise] run kill @e[tag=tori0]
execute as @e[tag=boss,tag=!sekino1,tag=!sekino2,scores={dummyhp=..0},tag=!reraise] run kill @s



##############################
#第一段階
##############################

#10秒毎にバーンフレイム
execute as @e[tag=sekino1,limit=1,tag=!skill,tag=!burnflame,scores={skill1=200..},nbt={OnGround:1b}] run tag @s add burnflame
execute as @e[tag=burnflame,limit=1] run function suiryu_ordeal:stage/10/burnflame

#60秒毎にバーストフレア
execute as @e[tag=sekino1,limit=1,tag=!skill,scores={skill3=1200..},nbt={OnGround:1b}] positioned as @s run function suiryu_ordeal:stage/10/burstflare

#70秒毎にフレアライト
execute as @e[tag=sekino1,limit=1,tag=!skill,tag=!light,scores={skill4=1400..},nbt={OnGround:1b}] run tag @s add light
execute as @e[tag=light,limit=1] run function suiryu_ordeal:stage/10/light

#体力0で第二段階
execute as @e[tag=sekino1,limit=1,tag=!skill,scores={dummyhp=..0}] run tag @s add 2nd
execute as @e[tag=2nd,limit=1,tag=sekino1] run function suiryu_ordeal:stage/10/2nd

##############################
#第一段階+第二段階
##############################

#60秒毎にゲイルブレイズ
execute as @e[tag=sekino,tag=!sekino3,limit=1,tag=!skill,tag=!gale,scores={skill2=1200..},nbt={OnGround:1b}] run tag @s add gale
execute as @e[tag=gale,limit=1] run function suiryu_ordeal:stage/10/gale

##############################
#第二段階
##############################

#35秒毎にフレアイグニート
execute as @e[tag=sekino2,limit=1,tag=!skill,tag=!burnflame,scores={skill1=700..},nbt={OnGround:1b}] run tag @s add igunito
execute as @e[tag=igunito,limit=1] run function suiryu_ordeal:stage/10/igunito

#体力600でバラド召喚
execute as @e[tag=sekino2,tag=!hp600,limit=1,tag=!skill,scores={dummyhp=..600},nbt={OnGround:1b}] run function suiryu_ordeal:stage/10/summon1

#体力300でマリエ召喚
execute as @e[tag=sekino2,tag=!hp300,limit=1,tag=!skill,scores={dummyhp=..300},nbt={OnGround:1b}] run function suiryu_ordeal:stage/10/summon2


#体力300でエンジェリックフレア
execute as @e[tag=sekino2,tag=!sp300,limit=1,tag=!skill,tag=!engel,scores={dummyhp=..300},nbt={OnGround:1b}] run tag @s add engel
execute as @e[tag=engel,limit=1] run function suiryu_ordeal:stage/10/engel

#体力0で第三段階
execute as @e[tag=sekino2,limit=1,tag=!skill,scores={dummyhp=..0}] run tag @s add 3rd
execute as @e[tag=3rd,limit=1,tag=sekino2] run function suiryu_ordeal:stage/10/3rd

##############################
#第三段階
##############################

#40秒毎にイグニートバースト
execute as @e[tag=sekino3,limit=1,tag=!skill,scores={skill1=800..},nbt={OnGround:1b}] at @s run function suiryu_ordeal:stage/10/igunitoburst

#被ダメ100毎にバーニングブレイズ
execute as @e[tag=sekino3,limit=1,tag=!skill,tag=!blaze,scores={skill5=100..},nbt={OnGround:1b}] run tag @s add blaze
execute as @e[tag=blaze,limit=1] run function suiryu_ordeal:stage/10/blaze

#体力900でフレイア召喚
execute as @e[tag=sekino3,tag=!hp900,limit=1,tag=!skill,scores={dummyhp=..900},nbt={OnGround:1b}] run function suiryu_ordeal:stage/10/summon3

#体力500でホムラ召喚、クリムゾンフレア
execute as @e[tag=sekino3,tag=!hp500,limit=1,tag=!skill,scores={dummyhp=..500},nbt={OnGround:1b}] run function suiryu_ordeal:stage/10/summon4
effect give @e[tag=hp500,limit=1] minecraft:strength 30 3

#体力150でクリムゾンブレイズ
execute as @e[tag=sekino3,tag=!sp150,limit=1,tag=!skill,tag=!ubb,scores={dummyhp=..150},nbt={OnGround:1b}] run tag @s add ubb
execute as @e[tag=ubb,limit=1] run function suiryu_ordeal:stage/10/ubb

##############################
#アスナ
##############################

#50秒毎にドラゴンフレア
execute as @e[tag=asuna,limit=1,tag=!skill,tag=!dragon,scores={skill1=1000..},nbt={OnGround:1b}] run tag @s add dragon
execute as @e[tag=dragon,limit=1] run function suiryu_ordeal:stage/10/dragon

##############################
#フェニックス
##############################

execute positioned as @e[tag=tori,limit=1] run particle minecraft:lava ~ ~ ~ 0 0 0 1 5
execute positioned as @e[tag=tori,limit=1] run particle minecraft:smoke ~ ~ ~ 0.2 0.2 0.2 0 10
execute positioned as @e[tag=tori,limit=1] run setblock ~ ~ ~ minecraft:fire keep
execute positioned as @e[tag=tori,limit=1,scores={skill1=23..}] if score @a[tag=player,sort=random,limit=1] hp matches 5 run playsound minecraft:entity.parrot.imitate.elder_guardian master @a ~ ~ ~ 2
scoreboard players set @e[tag=tori,limit=1,scores={skill1=23..}] skill1 0

#20秒毎に不死鳥の加護
execute as @e[tag=tori,limit=1,tag=!skill,scores={skill2=400..},nbt={OnGround:1b}] positioned as @s run function suiryu_ordeal:stage/10/kago
execute as @e[tag=regene,scores={healthboost=20..}] run scoreboard players add @s dummyhp 2
execute as @e[tag=regene,tag=!tori,scores={healthboost=20..,dummyhp=1001..}] run scoreboard players set @s dummyhp 1000
execute as @e[tag=regene,tag=tori,scores={healthboost=20..,dummyhp=701..}] run scoreboard players set @s dummyhp 700
execute as @e[tag=regene,scores={healthboost=20..}] run scoreboard players set @s healthboost 0
execute as @e[tag=regene,scores={attackboost=600..},tag=!hp500] run tag @s remove regene

##############################
#マリエ
##############################

#40秒毎に世滅の炎
execute as @e[tag=marie,limit=1,tag=!skill,tag=!marie1,scores={skill1=800..},nbt={OnGround:1b}] run tag @s add marie1
execute as @e[tag=marie1,limit=1] run function suiryu_ordeal:stage/10/marie1

#170秒毎にバーニングスカーレット
execute as @e[tag=marie,limit=1,tag=!skill,tag=!marie2,scores={skill2=3400..},nbt={OnGround:1b}] run tag @s add marie2
execute as @e[tag=marie2,limit=1] run function suiryu_ordeal:stage/10/marie2

##############################
#フレイア
##############################

#20秒毎に女神の聖炎
execute as @e[tag=fureia,limit=1,tag=!skill,tag=!fureia1,scores={skill1=400..},nbt={OnGround:1b}] run tag @s add fureia1
execute as @e[tag=fureia1,limit=1] run function suiryu_ordeal:stage/10/fureia1

#30秒毎に女神の祝福
execute as @e[tag=fureia,limit=1,tag=!skill,tag=!fureia2,scores={skill2=600..},nbt={OnGround:1b}] run tag @s add fureia2
execute as @e[tag=fureia2,limit=1] run function suiryu_ordeal:stage/10/fureia2

##############################
#ホムラ
##############################

#25秒毎にフレアイグニファイ
execute as @e[tag=homura,limit=1,tag=!skill,tag=!homura1,scores={skill1=500..},nbt={OnGround:1b}] run tag @s add homura1
execute as @e[tag=homura1,limit=1] run function suiryu_ordeal:stage/10/homura1

#60秒毎にブレイブバーニング
execute as @e[tag=homura,limit=1,tag=!skill,tag=!homura2,scores={skill2=1200..},nbt={OnGround:1b}] run tag @s add homura2
execute as @e[tag=homura2,limit=1] run function suiryu_ordeal:stage/10/homura2

#体力200で精神統一、その20秒後にフレアブラスト
execute as @e[tag=homura,limit=1,tag=!skill,tag=!hp200,tag=!homura3,scores={dummyhp=..200},nbt={OnGround:1b}] run tag @s add homura3
execute as @e[tag=homura3,limit=1] run function suiryu_ordeal:stage/10/homura3

