##############################
#叛神の試練メイン実行
##############################

#初期準備
execute if score #setman stage matches 0 run function suiryu_ordeal:stage/13/first

#スコア増加
scoreboard players add @e[tag=rucius,limit=1] skill1 1
scoreboard players add @e[tag=rucius,limit=1] skill4 1
scoreboard players add @e[tag=rucius,limit=1] skill5 1
scoreboard players add @e[tag=rucius,tag=!rucius3,limit=1] skill6 1
scoreboard players add @e[tag=rucius1,limit=1] skill7 1
scoreboard players add @e[tag=rucius1,limit=1] skill8 1
scoreboard players add @e[tag=rucius,tag=!rucius2,limit=1] skill9 1
scoreboard players add @e[tag=rucius1,limit=1] skill10 1
scoreboard players add @e[tag=rucius1,limit=1,tag=hp260] logout 1



execute if entity @e[tag=rucius1,limit=1] run effect clear @a minecraft:night_vision
effect clear @e[tag=rucius,limit=1] minecraft:wither

execute if score @e[tag=rucius,limit=1] skill1 matches 1 positioned as @a[tag=player,limit=1] run playsound minecraft:ambient.cave master @a ~ ~ ~ 2
scoreboard players set @e[tag=rucius,limit=1,scores={skill1=200..}] skill1 0

##############################
#ダメージ計算
##############################

#体力検知
execute as @e[tag=boss,limit=1] store result score @s hp run data get entity @s Health

#ダメージ量検知
execute as @e[tag=boss,limit=1] run scoreboard players operation @s dead -= @s hp
execute as @e[tag=lightbarrier,limit=1] run scoreboard players operation @s speedboost += @s dead
execute as @e[tag=lightbarrier,limit=1,scores={dead=1..}] run scoreboard players set @s dead 0
execute as @e[tag=godbarrier,limit=1,scores={dead=2..}] run scoreboard players set @s dead 1
execute as @e[tag=rucius,limit=1,tag=!rucius3,tag=!godp] run scoreboard players operation @s healthboost += @s dead
execute as @e[tag=rucius1,limit=1,tag=!xp] run scoreboard players operation @s hasteboost += @s dead
execute as @e[tag=rucius1,limit=1,tag=!lifevoid] run scoreboard players operation @s speedboost += @s dead
execute as @e[tag=rucius1,limit=1,tag=!lostpower] run scoreboard players operation @s jumpboost += @s dead
execute as @e[tag=rucius1,limit=1,tag=hp260] run scoreboard players operation @s regeneration += @s dead
execute as @e[tag=godbarrier,limit=1] run scoreboard players operation @s hasteboost += @s dead
execute as @e[tag=rucius2,limit=1,tag=!gainpower] run scoreboard players operation @s jumpboost += @s dead


#体力計算
execute as @e[tag=boss,limit=1,scores={dead=1..},tag=!godf,tag=!gode,tag=!iv,tag=!gend] run scoreboard players operation @s dummyhp -= @s dead
execute as @e[tag=lightbarrier,limit=1,scores={dead=0}] run data merge entity @s {Health:1024f}
execute as @e[tag=boss,limit=1,scores={dead=1..}] run data merge entity @s {Health:1024f}
scoreboard players set @e[tag=boss,limit=1] dead 1024
execute as @e[tag=boss,limit=1] store result bossbar suiryu:boss value run scoreboard players get @s dummyhp
execute as @e[tag=rucius3,tag=reraise,limit=1,scores={dummyhp=..0}] run function suiryu_ordeal:stage/13/reraise
execute as @e[tag=rucius3,tag=!reraise,limit=1,scores={dummyhp=..0}] run scoreboard players remove #stageman skill2 1
execute as @e[tag=rucius3,tag=!reraise,limit=1,scores={dummyhp=..0}] run data merge entity @s {HandItems:[{id:"minecraft:acacia_leaves",Count:1b},{}],HandDropChances:[-327.67F,0.85F]}
execute as @e[tag=rucius3,tag=!reraise,limit=1,scores={dummyhp=..0}] run kill @e[tag=rucius0,limit=1]
execute as @e[tag=rucius3,tag=!reraise,limit=1,scores={dummyhp=..0}] run kill @s



##############################
#第一段階
##############################

#最初、体力975/650/325でギルティエンドレス
execute as @e[tag=rucius1,limit=1,tag=!skill,tag=hp650,tag=!hp325,tag=!endless,scores={dummyhp=..325}] run tag @s add endless
execute as @e[tag=rucius1,limit=1,tag=!skill,tag=hp975,tag=!hp650,tag=!endless,scores={dummyhp=..650}] run tag @s add endless
execute as @e[tag=rucius1,limit=1,tag=!skill,tag=hp1300,tag=!hp975,tag=!endless,scores={dummyhp=..975}] run tag @s add endless
execute as @e[tag=endless,limit=1] run function suiryu_ordeal:stage/13/endless

#40秒毎に神の一撃
execute as @e[tag=rucius1,limit=1,tag=!skill,tag=!god,scores={skill5=800..}] run tag @s add god
execute as @e[tag=god,limit=1] run function suiryu_ordeal:stage/13/god

#50秒毎にゴッドファルス
execute as @e[tag=rucius1,limit=1,tag=!skill,tag=!godf,scores={skill7=1000..}] run tag @s add godf
execute as @e[tag=godf,limit=1] run function suiryu_ordeal:stage/13/godf

#70秒毎にゴッドフォール
execute as @e[tag=rucius1,limit=1,tag=!skill,tag=!godfall,scores={skill8=1400..}] run tag @s add godfall
execute as @e[tag=godfall,limit=1] run function suiryu_ordeal:stage/13/godfall

#150秒毎に神の一撃
execute as @e[tag=rucius1,limit=1,tag=!skill,tag=!god,scores={skill6=3000..}] run tag @s add god1
execute as @e[tag=god1,limit=1] run function suiryu_ordeal:stage/13/god1

#190秒毎にインフィニティヴォイド
execute as @e[tag=rucius1,limit=1,tag=!skill,tag=!iv,scores={skill10=3800..}] run tag @s add iv
execute as @e[tag=iv,limit=1] run function suiryu_ordeal:stage/13/iv

#被ダメ160毎にエクスパルサー
execute as @e[tag=rucius1,limit=1,tag=!skill,tag=!xp,scores={hasteboost=180..}] run tag @s add xp
execute as @e[tag=xp,limit=1] run function suiryu_ordeal:stage/13/xp

#被ダメ180毎にライフヴォイド
execute as @e[tag=rucius1,limit=1,tag=!skill,tag=!lifevoid,scores={speedboost=180..}] run tag @s add lifevoid
execute as @e[tag=lifevoid,limit=1] run function suiryu_ordeal:stage/13/lifevoid

#被ダメ200毎にロストパワー
execute as @e[tag=rucius1,limit=1,tag=!skill,tag=!lostpower,scores={jumpboost=200..}] run tag @s add lostpower
execute as @e[tag=lostpower,limit=1] run function suiryu_ordeal:stage/13/lostpower

#体力600、体力260以下30秒毎に被ダメ100超でワールドエンド
execute as @e[tag=rucius1,limit=1,tag=!skill,tag=!hp600,tag=!worldend,scores={dummyhp=..600}] run tag @s add worldend
execute as @e[tag=rucius1,limit=1,tag=!skill,tag=!hp260,scores={dummyhp=..260}] run fill -12 13 12 12 13 -12 minecraft:quartz_slab[type=double] replace minecraft:quartz_slab
execute as @e[tag=rucius1,limit=1,tag=!skill,tag=!hp260,scores={dummyhp=..260}] run tag @s add hp260
scoreboard players set @e[tag=hp260,limit=1,tag=rucius1,scores={logout=600..}] regeneration 0
scoreboard players set @e[tag=hp260,limit=1,tag=rucius1,scores={logout=600..}] logout 0
execute as @e[tag=rucius1,limit=1,tag=!skill,tag=hp260,tag=!worldend,scores={regeneration=100..}] run tag @s add worldend
execute as @e[tag=worldend,limit=1] run function suiryu_ordeal:stage/13/worldend

#体力0で第二段階
execute as @e[tag=rucius1,limit=1,tag=!skill,scores={dummyhp=..0}] run tag @s add 2nd
execute as @e[tag=2nd,limit=1,tag=rucius1] run function suiryu_ordeal:stage/13/2nd

##############################
#第一段階＋第二段階
##############################

#被ダメ120毎にゴッドパルサー
execute as @e[tag=rucius,tag=!rucius3,limit=1,tag=!skill,tag=!godp,scores={healthboost=120..}] run tag @s add godp
execute as @e[tag=godp,limit=1] run function suiryu_ordeal:stage/13/godp

##############################
#第一段階＋第三段階
##############################

#ゴッドエンド
execute as @e[tag=rucius1,limit=1,tag=!skill,tag=!gode,scores={skill9=3400..}] run tag @s add gode
execute as @e[tag=rucius3,limit=1,tag=!skill,tag=!gode,scores={skill9=1000..}] run tag @s add gode
execute as @e[tag=gode,limit=1] run function suiryu_ordeal:stage/13/gode

##############################
#第二段階
##############################

execute as @e[tag=rucius2,limit=1] positioned as @s facing entity @a[tag=player,limit=1] eyes run tp @s ~ ~ ~ ~ ~

#最初にワールドエンド
execute as @e[tag=worldend0,limit=1] run function suiryu_ordeal:stage/13/worldend0

#30秒毎にリフレクション
execute as @e[tag=rucius2,limit=1,tag=!skill,tag=!rf,scores={skill5=600..}] run tag @s add rf
execute as @e[tag=rf,limit=1] run function suiryu_ordeal:stage/13/rf
execute positioned as @a[tag=player,scores={dummyhp=1..}] run particle minecraft:dust 2 0 0 0.5 ~ ~1 ~ 0.3 0.5 0.3 1 30 force
effect give @a[tag=player,scores={dummyhp=401}] minecraft:instant_damage 1 1
effect give @a[tag=player,scores={dummyhp=201}] minecraft:instant_damage 1 1
effect give @a[tag=player,scores={dummyhp=1}] minecraft:instant_damage 1 1
scoreboard players remove @a[tag=player,scores={dummyhp=1..}] dummyhp 1

#50秒毎にライトバリア
execute as @e[tag=rucius2,limit=1,tag=!skill,scores={skill6=1000..}] run function suiryu_ordeal:stage/13/lightbarrier
execute if entity @e[tag=lightbarrier,limit=1] run particle minecraft:end_rod 0 25 -2 2 6 2 0 10 force
execute as @e[tag=lightbarrier,limit=1,scores={speedboost=100..}] run function suiryu_ordeal:stage/13/lightbarrier0

#体力1170/780/575でゴッドバリア
execute as @e[tag=rucius2,limit=1,tag=!skill,tag=hp780,tag=!hp575,tag=!godbarrier,scores={dummyhp=..575}] run function suiryu_ordeal:stage/13/godbarrier
execute as @e[tag=rucius2,limit=1,tag=!skill,tag=hp1170,tag=!hp780,tag=!godbarrier,scores={dummyhp=..780}] run function suiryu_ordeal:stage/13/godbarrier
execute as @e[tag=rucius2,limit=1,tag=!skill,tag=!hp1170,tag=!godbarrier,scores={dummyhp=..1170}] run function suiryu_ordeal:stage/13/godbarrier
execute if entity @e[tag=godbarrier,limit=1] run particle minecraft:sweep_attack 0 25 -2 2 6 2 4 30 force
execute as @e[tag=godbarrier,limit=1,scores={hasteboost=70..}] run function suiryu_ordeal:stage/13/godbarrier0

#体力845でギルティエンド
execute as @e[tag=rucius2,limit=1,tag=!hp845,tag=!skill,tag=!gend,scores={dummyhp=..845}] run tag @s add gend
execute as @e[tag=gend,limit=1] run function suiryu_ordeal:stage/13/gend

#被ダメ90毎にゲインパワー
execute as @e[tag=rucius2,limit=1,tag=!skill,tag=!gainpower,scores={jumpboost=90..}] run tag @s add gainpower
execute as @e[tag=gainpower,limit=1] run function suiryu_ordeal:stage/13/gainpower

#体力0で第三段階
execute as @e[tag=rucius2,limit=1,tag=!skill,scores={dummyhp=..0}] run tag @s add 3rd
execute as @e[tag=3rd,limit=1,tag=rucius2] run function suiryu_ordeal:stage/13/3rd

##############################
#第三段階
##############################

execute as @e[tag=rucius3,limit=1] at @s run tp @e[tag=rucius0,limit=1] ~ ~ ~ ~ ~

#40秒毎にセイクリッドソング
execute as @e[tag=rucius3,limit=1,tag=!skill,tag=!song,scores={skill5=800..}] run tag @s add song
execute as @e[tag=song,limit=1] run function suiryu_ordeal:stage/13/song
execute positioned as @e[tag=reraise,limit=1] run particle minecraft:instant_effect ~ ~3.3 ~ 0 0 0 0 1 force


##############################
#共通
##############################

#ギルティパワー
execute as @e[tag=rucius,tag=!rucius2,limit=1,tag=!skill,tag=!gpower,scores={skill4=600..}] run tag @s add gpower
execute as @e[tag=rucius2,limit=1,tag=!skill,tag=!gpower,scores={skill4=1000..}] run tag @s add gpower
execute as @e[tag=rucius2,limit=1,tag=!skill,tag=hp910,tag=!hp520,tag=!gpower,scores={dummyhp=..520}] run tag @s add gpower
execute as @e[tag=rucius2,limit=1,tag=!skill,tag=!hp910,tag=!gpower,scores={dummyhp=..910}] run tag @s add gpower
execute as @e[tag=gpower,limit=1] run function suiryu_ordeal:stage/13/gpower


