##############################
#女神の試練メイン実行
##############################

#初期準備
execute if score #setman stage matches 0 run function suiryu_ordeal:stage/14/first

#スコア増加
scoreboard players add @e[tag=asami,limit=1] skill1 1
scoreboard players add @e[tag=asami,limit=1] skill3 1
scoreboard players add @e[tag=asami3,limit=1,scores={dummyhp=..700}] skill4 1
scoreboard players add @e[tag=asami,limit=1] skill5 1
scoreboard players add @e[tag=marisu,limit=1] skill1 1
scoreboard players add @e[tag=marisu,limit=1] skill2 1
scoreboard players add @e[tag=ran,limit=1] skill1 1
scoreboard players add @e[tag=ran,limit=1] skill2 1
scoreboard players add @e[tag=sekino,limit=1] skill1 1
scoreboard players add @e[tag=reraise,limit=1] skill10 1

#リレイズエフェクト
execute positioned as @e[tag=reraise,limit=1] run particle minecraft:instant_effect ~ ~2 ~ 0 0 0 0 1 force

##############################
#ダメージ計算
##############################

#体力検知
execute as @e[tag=boss] store result score @s hp run data get entity @s Health

#ダメージ量検知
execute as @e[tag=boss] run scoreboard players operation @s dead -= @s hp
execute as @e[tag=light,limit=1] run scoreboard players operation @s healthboost += @s dead
execute as @e[tag=asami2,tag=!light,limit=1] run scoreboard players operation @s jumpboost += @s dead
execute if score @e[tag=clight4,limit=1] dead matches 3.. run effect give @a[tag=player] minecraft:instant_damage 1 0
execute as @e[tag=boss,tag=!asami,scores={dead=1..}] run scoreboard players operation @s dead += @a[tag=player,limit=1,sort=random] hp


#体力計算
execute as @e[tag=boss,scores={dead=1..}] run scoreboard players operation @s dummyhp -= @s dead
execute as @e[tag=boss,scores={dead=1..}] run data merge entity @s {Health:1024f}
scoreboard players set @e[tag=boss] dead 1024
execute as @e[tag=asami,limit=1] store result bossbar suiryu:boss value run scoreboard players get @s dummyhp
execute as @e[tag=marisu,limit=1] store result bossbar suiryu:boss1 value run scoreboard players get @s dummyhp
execute as @e[tag=ran,limit=1] store result bossbar suiryu:boss2 value run scoreboard players get @s dummyhp
execute as @e[tag=kairu,limit=1] store result bossbar suiryu:boss3 value run scoreboard players get @s dummyhp
execute as @e[tag=sekino,limit=1] store result bossbar suiryu:boss4 value run scoreboard players get @s dummyhp
execute as @e[tag=asami3,tag=reraise,scores={dummyhp=..0}] positioned as @s run function suiryu_ordeal:stage/14/reraise
execute as @e[tag=asami3,tag=!reraise,limit=1,scores={dummyhp=..0}] run bossbar set suiryu:boss visible false
execute as @e[tag=marisu,limit=1,scores={dummyhp=..0}] run bossbar set suiryu:boss1 visible false
execute as @e[tag=ran,limit=1,scores={dummyhp=..0}] run bossbar set suiryu:boss2 visible false
execute as @e[tag=kairu,limit=1,scores={dummyhp=..0}] run bossbar set suiryu:boss3 visible false
execute as @e[tag=sekino,limit=1,scores={dummyhp=..0}] run bossbar set suiryu:boss4 visible false
execute as @e[tag=boss,tag=!asami1,tag=!asami2,tag=!reraise,scores={dummyhp=..0}] run scoreboard players remove #stageman skill2 1
execute as @e[tag=asami3,tag=!reraise,limit=1,scores={dummyhp=..0}] run data merge entity @s {NoAI:0b,ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{display:{color:16580607}}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:16777215}}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:16777215}}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"abfec979-f6f5-4cf1-8c19-e0adb2c0846e",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvYmFmM2RmN2Y4OTBlYzFlYTZiZjUxNmE2OTljZWY5OGZhNWM0OGIyODk4YjNmOGMxNjZkMjVhNmY5NzhmYSJ9fX0="}]}}}}],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F]}
execute as @e[tag=marisu,limit=1,scores={dummyhp=..0}] run data merge entity @s {NoAI:0b,HandItems:[{id:"minecraft:iron_sword",Count:1b,tag:{display:{Name:"{\"text\":\"滅界鬼斬剣\",\"color\":\"green\",\"italic\":false}"},Unbreakable:1b,AttributeModifiers:[{AttributeName:"generic.attackDamage",Name:"generic.attackDamage",Amount:20,Operation:0,UUIDLeast:343842,UUIDMost:422798,Slot:"mainhand"},{AttributeName:"generic.armor",Name:"generic.armor",Amount:-1,Operation:1,UUIDLeast:10857,UUIDMost:646116,Slot:"mainhand"}]}},{}],HandDropChances:[-327.67F,0.85F],ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{AttributeModifiers:[{AttributeName:"generic.movementSpeed",Name:"generic.movementSpeed",Amount:0.12,Operation:1,UUIDLeast:12917,UUIDMost:842870,Slot:"feet"}]}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:12105912}}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:22284}}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"e9de46c9-69d4-45a1-85b8-9ccc57663695",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvMzE4MThjY2E1NDM4YmQ5ZTg5OTIzNjk0MWQwZTE3NjdiNTA1MzdhYjk4MThjZjAxNDRjMzk0NTI4YjVlMzQwIn19fQ=="}]}}}}],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F]}
execute as @e[tag=ran,limit=1,scores={dummyhp=..0}] run data merge entity @s {NoAI:0b,HandItems:[{id:"minecraft:golden_sword",Count:1b,tag:{Enchantments:[{id:"minecraft:knockback",lvl:1}]}},{id:"minecraft:shield",Count:1b,tag:{BlockEntityTag:{Base:0,Patterns:[{Pattern:gru,Color:4},{Pattern:gra,Color:4},{Pattern:flo,Color:0},{Pattern:sc,Color:4},{Pattern:mr,Color:4},{Pattern:sc,Color:0}]}}}],HandDropChances:[-327.67F,-327.67F],ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{display:{color:13626633},AttributeModifiers:[{AttributeName:"generic.movementSpeed",Name:"generic.movementSpeed",Amount:0.2,Operation:1,UUIDLeast:754203,UUIDMost:707779,Slot:"feet"}]}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:16777215}}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:15662848}}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"2293a0bc-49ff-4ea1-8973-751d431dc299",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvYWZkMTdjNzBmYzdkNGIwOTU3NzBmZjJhMjk1OGUxY2ZkNTRlY2M4OTI3NjQ4Zjc2YmYyZDFkYmJhNzMyNSJ9fX0="}]}}}}],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F]}
execute as @e[tag=kairu,limit=1,scores={dummyhp=..0}] run data merge entity @s {NoAI:0b,HandItems:[{id:"minecraft:diamond_axe",Count:1b,tag:{display:{Name:"{\"text\":\"氷龍斧フロストアックス改\",\"color\":\"aqua\",\"italic\":false}",Lore:["§r攻撃時に3秒間攻撃力上昇"]}}},{}],HandDropChances:[-327.67F,0.85F],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F],ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{display:{color:4791551}}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:16777215}}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:24319}}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"98eb571e-d5a9-4fd2-b9af-1d219fc7f3e2",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvYjc0YzdiOGE3MjdlMjk3YTIwODBiNDI5NTg5ZWY0M2RkMGYyYmI2YjAxNzJmOTc1YTdiYTQ5ZGUxMWRlNGFiZCJ9fX0="}]}}}}]}
execute as @e[tag=sekino,limit=1,scores={dummyhp=..0}] run data merge entity @s {NoAI:0b,HandItems:[{id:"minecraft:diamond_sword",Count:1b,tag:{display:{Name:"{\"text\":\"炎聖剣イグニート\",\"color\":\"red\",\"italic\":false}"},Enchantments:[{id:"minecraft:fire_aspect",lvl:10}]}},{}],HandDropChances:[-327.67F,0.85F],ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{display:{color:8732187},Enchantments:[{id:"minecraft:feather_falling",lvl:1}],AttributeModifiers:[{AttributeName:"generic.movementSpeed",Name:"generic.movementSpeed",Amount:0.15,Operation:1,UUIDLeast:321277,UUIDMost:791854,Slot:"feet"}]}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:8716288},Enchantments:[{id:"minecraft:protection",lvl:1}]}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:16711680},Enchantments:[{id:"minecraft:fire_protection",lvl:100}]}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"fb44ae6b-192e-4975-a152-2a953a6c73c9",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvNGNiYzI0NzNiNDc3OWJlZGIyN2I1ZDRiYjRiNTVhNGUxMzYwMjBiN2JmY2QyNmRjZmUxM2U2ZjAwMDcwZDUwZSJ9fX0="}]}}}}],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F]}
execute as @e[tag=asami3,limit=1,tag=!reraise,scores={dummyhp=..0}] run kill @e[tag=asamiarmorstand]
execute as @e[tag=marisu,limit=1,scores={dummyhp=..0}] run kill @e[tag=marisuarmorstand]
execute as @e[tag=ran,limit=1,scores={dummyhp=..0}] run kill @e[tag=ranarmorstand]
execute as @e[tag=kairu,limit=1,scores={dummyhp=..0}] run kill @e[tag=kairuarmorstand]
execute as @e[tag=sekino,limit=1,scores={dummyhp=..0}] run kill @e[tag=sekinoarmorstand]
execute as @e[tag=boss,tag=!asami1,tag=!asami2,tag=!reraise,scores={dummyhp=..0}] run effect clear @s minecraft:invisibility
execute as @e[tag=boss,tag=!asami1,tag=!asami2,tag=!reraise,scores={dummyhp=..0}] run kill @s



##############################
#第一段階
##############################

#60秒毎に光
execute as @e[tag=asami1,limit=1,tag=!light,scores={skill1=1200..}] run tag @s add light
execute positioned as @e[tag=light,limit=1] run particle minecraft:end_rod ~ ~1 ~ 0.3 0.5 0.3 0 3 force
execute as @e[tag=asami1,tag=light,limit=1,scores={skill1=1400..,healthboost=..19}] run function suiryu_ordeal:stage/14/notlight
execute as @e[tag=asami1,tag=light,limit=1,tag=!skill,tag=!swhite,scores={healthboost=20..},nbt={OnGround:1b}] run tag @s add swhite

#体力1050でマリス、ラン召喚
execute as @e[tag=asami1,limit=1,tag=!hp1050,tag=!skill,scores={dummyhp=..1050}] run function suiryu_ordeal:stage/14/summon1

#体力0で第二段階
execute as @e[tag=asami1,limit=1,tag=!skill,scores={dummyhp=..0}] run tag @s add 2nd
execute as @e[tag=2nd,limit=1,tag=asami1] run function suiryu_ordeal:stage/14/2nd

##############################
#第二段階
##############################

#20秒毎に光
execute as @e[tag=asami2,limit=1,tag=!light,scores={skill1=400..}] run tag @s add light
execute as @e[tag=asami2,tag=light,limit=1,scores={skill1=600..,healthboost=40..}] run function suiryu_ordeal:stage/14/notlight
execute as @e[tag=asami2,tag=light,limit=1,tag=!skill,tag=!swhite,scores={skill1=600..,healthboost=..39},nbt={OnGround:1b}] run tag @s add swhite
execute as @e[tag=swhite,limit=1] run function suiryu_ordeal:stage/14/swhite

#光が無い間に被ダメ50以上で光の脈動
execute as @e[tag=asami2,tag=!light,limit=1,tag=!skill,tag=!swhite,scores={jumpboost=50..},nbt={OnGround:1b}] run tag @s add light0
execute as @e[tag=light0,limit=1] run function suiryu_ordeal:stage/14/light0
execute as @e[tag=asami2,limit=1,scores={speedboost=1..}] run effect clear @a[tag=player] minecraft:resistance
execute as @e[tag=asami2,limit=1,scores={speedboost=1..}] run scoreboard players remove @s speedboost 1

#体力1050でカイル、セキノ召喚
execute as @e[tag=asami2,limit=1,tag=!hp1050,tag=!skill,scores={dummyhp=..1050}] run function suiryu_ordeal:stage/14/summon2

#体力0で第三段階
execute as @e[tag=asami2,limit=1,tag=!skill,scores={dummyhp=..0}] run tag @s add 3rd
execute as @e[tag=3rd,limit=1,tag=asami2] run function suiryu_ordeal:stage/14/3rd

##############################
#第三段階
##############################

#60秒毎に光
execute as @e[tag=asami3,limit=1,scores={skill1=1200..}] run function suiryu_ordeal:stage/14/clight
execute positioned as @e[tag=clight1,limit=1] run particle minecraft:dust 1 0 0 0.5 ~ ~1 ~ 0.3 0.5 0.3 0 10 force
execute positioned as @e[tag=clight2,limit=1] run particle minecraft:dust 0 0 1 0.5 ~ ~1 ~ 0.3 0.5 0.3 0 10 force
execute positioned as @e[tag=clight3,limit=1] run particle minecraft:dust 0 1 0 0.5 ~ ~1 ~ 0.3 0.5 0.3 0 10 force
execute positioned as @e[tag=clight4,limit=1] run particle minecraft:dust 1 1 0 0.5 ~ ~1 ~ 0.3 0.5 0.3 0 10 force
execute positioned as @e[tag=clight5,limit=1] run particle minecraft:dust 255 255 255 0.5 ~ ~1 ~ 0.3 0.5 0.3 0 10 force

#体力280でリレイズ
execute as @e[tag=asami3,tag=!spreraise,limit=1,tag=!reraise,scores={dummyhp=..280}] run tag @s add reraise
execute positioned as @e[tag=reraise,limit=1,scores={skill10=200..}] run particle minecraft:end_rod ~ ~1 ~ 0.3 0.5 0.3 0 3 force
execute positioned as @e[tag=reraise,limit=1,scores={skill10=400..}] run particle minecraft:end_rod ~ ~1 ~ 0.3 0.5 0.3 1 3 force
execute as @e[tag=reraise,limit=1,scores={skill10=600..,dummyhp=100..}] run tag @s add egate
execute as @e[tag=egate,limit=1] run function suiryu_ordeal:stage/14/egate
execute as @e[tag=reraise,limit=1,scores={skill10=400..,dummyhp=..99}] run function suiryu_ordeal:stage/14/notgate

#体力670/525/350/140/0になる度に聖なる口付け
execute as @e[tag=asami3,limit=1,tag=!skill,tag=!sp140,tag=!spkiss,scores={dummyhp=..140},nbt={OnGround:1b}] run tag @s add spkiss
execute as @e[tag=asami3,limit=1,tag=!skill,tag=!sp350,tag=!spkiss,scores={dummyhp=..350},nbt={OnGround:1b}] run tag @s add spkiss
execute as @e[tag=asami3,limit=1,tag=!skill,tag=!sp525,tag=!spkiss,scores={dummyhp=..525},nbt={OnGround:1b}] run tag @s add spkiss
execute as @e[tag=asami3,limit=1,tag=!skill,tag=!sp670,tag=!spkiss,scores={dummyhp=..670},nbt={OnGround:1b}] run tag @s add spkiss
execute as @e[tag=spkiss,limit=1] run function suiryu_ordeal:stage/14/spkiss

##############################
#共通
##############################

#25秒毎にピュアハート
execute as @e[tag=asami,limit=1,tag=!skill,tag=!ph,scores={skill3=500..},nbt={OnGround:1b}] run tag @s add ph
execute as @e[tag=ph,limit=1] run function suiryu_ordeal:stage/14/ph

#35秒毎にピュアホワイト
execute as @e[tag=asami,limit=1,tag=!skill,tag=!pw,scores={skill5=700..},nbt={OnGround:1b}] run tag @s add pw
execute as @e[tag=pw,limit=1] run function suiryu_ordeal:stage/14/pw

#体力840/560/280でセイクリッドキス
execute as @e[tag=asami,limit=1,tag=!skill,tag=hp560,tag=!hp280,tag=!skiss,scores={dummyhp=..280},nbt={OnGround:1b}] run tag @s add skiss
execute as @e[tag=asami,limit=1,tag=!skill,tag=hp840,tag=!hp560,tag=!skiss,scores={dummyhp=..560},nbt={OnGround:1b}] run tag @s add skiss
execute as @e[tag=asami,limit=1,tag=!skill,tag=!hp840,tag=!skiss,scores={dummyhp=..840},nbt={OnGround:1b}] run tag @s add skiss
execute as @e[tag=asami3,limit=1,tag=!skill,tag=!skiss,scores={skill4=1400..},nbt={OnGround:1b}] run tag @s add skiss
execute as @e[tag=skiss,limit=1] run function suiryu_ordeal:stage/14/skiss

##############################
#マリス
##############################

#30秒毎に滅星斬
execute as @e[tag=marisu,limit=1,tag=!skill,tag=!hosi,scores={skill2=600..},nbt={OnGround:1b}] run tag @s add hosi
execute as @e[tag=hosi,limit=1] run function suiryu_ordeal:stage/14/hosi

#40秒毎に滅鬼神連斬
execute as @e[tag=marisu,limit=1,tag=!skill,tag=!mkijin,scores={skill1=800..},nbt={OnGround:1b}] run tag @s add mkijin
execute as @e[tag=mkijin,limit=1] run function suiryu_ordeal:stage/14/mkijin

#体力700で真・鬼神斬
execute as @e[tag=marisu,limit=1,tag=!hp700,tag=!skill,tag=!skijin,scores={dummyhp=..700},nbt={OnGround:1b}] run tag @s add skijin
execute as @e[tag=skijin,limit=1] run function suiryu_ordeal:stage/14/skijin

#アサミの体力280で奥義「絶界」
execute as @e[tag=marisu,limit=1,tag=!hp280,tag=sp280,tag=!skill,tag=!zetu,nbt={OnGround:1b}] run tag @s add zetu
execute as @e[tag=zetu,limit=1] run function suiryu_ordeal:stage/14/zetu

##############################
#ラン
##############################

#45秒毎に雷響陣 癒界
execute as @e[tag=ran,limit=1,tag=!skill,tag=!ran1,scores={skill1=900..},nbt={OnGround:1b}] run tag @s add ran1
execute as @e[tag=ran1,limit=1] run function suiryu_ordeal:stage/14/ran1

#70秒毎に雷響陣 雷波
execute as @e[tag=ran,limit=1,tag=!skill,tag=!ran2,scores={skill2=1400..},nbt={OnGround:1b}] run tag @s add ran2
execute as @e[tag=ran2,limit=1] run function suiryu_ordeal:stage/14/ran2

#体力220で雷響陣 幻鳳
execute as @e[tag=ran,limit=1,tag=!skill,tag=!hp220,tag=!ran3,scores={dummyhp=..220},nbt={OnGround:1b}] run tag @s add ran3
execute as @e[tag=ran3,limit=1] run function suiryu_ordeal:stage/14/ran3

##############################
#カイル
##############################

#真・ライトアックスによる追撃
execute positioned as @a[tag=player,scores={dummyhp=1..}] run particle minecraft:dust 2 0 0 0.5 ~ ~1 ~ 0.3 0.5 0.3 1 30 force
effect give @a[tag=player,scores={dummyhp=401}] minecraft:instant_damage 1 0
effect give @a[tag=player,scores={dummyhp=201}] minecraft:instant_damage 1 0
effect give @a[tag=player,scores={dummyhp=1}] minecraft:instant_damage 1 0
scoreboard players remove @a[tag=player,scores={dummyhp=1..}] dummyhp 1

#体力700で龍斧陣
execute as @e[tag=kairu,limit=1,tag=!skill,tag=!hp700,tag=!ryuujin,scores={dummyhp=..700},nbt={OnGround:1b}] run tag @s add ryuujin
execute as @e[tag=ryuujin,limit=1] run function suiryu_ordeal:stage/14/ryuujin

#体力280で冥龍閃斧 破斧撃
execute as @e[tag=kairu,limit=1,tag=!skill,tag=!hp280,tag=!meiryuu,scores={dummyhp=..280},nbt={OnGround:1b}] run tag @s add meiryuu
execute as @e[tag=meiryuu,limit=1] run function suiryu_ordeal:stage/14/meiryuu

##############################
#セキノ
##############################

#60秒毎にゲイルブレイズ
execute as @e[tag=sekino,limit=1,tag=!skill,tag=!gale,scores={skill1=1200..},nbt={OnGround:1b}] run tag @s add gale
execute as @e[tag=gale,limit=1] run function suiryu_ordeal:stage/14/gale

#体力700でクリムゾンフレア
execute as @e[tag=sekino,limit=1,tag=!skill,tag=!sekino700,scores={dummyhp=..700},nbt={OnGround:1b}] run function suiryu_ordeal:stage/14/sekino700
effect give @e[tag=sekino700,limit=1] minecraft:strength 30 3

#体力560でクリムゾンブレイズ
execute as @e[tag=sekino,tag=!hp560,limit=1,tag=!skill,tag=!sekino1,scores={dummyhp=..560},nbt={OnGround:1b}] run tag @s add sekino1
execute as @e[tag=sekino1,limit=1] run function suiryu_ordeal:stage/14/sekino1

#アサミの体力280でクリムゾンブレイズ
execute as @e[tag=sekino,limit=1,tag=!hp280,tag=sp280,tag=!skill,tag=!sekino2,nbt={OnGround:1b}] run tag @s add sekino2
execute as @e[tag=sekino2,limit=1] run function suiryu_ordeal:stage/14/sekino2


