##############################
#幻霊の試練メイン実行
##############################

#初期準備
execute if score #setman stage matches 0 run function suiryu_ordeal:stage/19/first

#スコア増加
scoreboard players add @e[tag=irumea,limit=1] skill1 1
scoreboard players add @e[tag=irumea,limit=1] skill2 1
scoreboard players add @e[tag=irumea,limit=1] skill3 1
scoreboard players add @e[tag=irumea,limit=1] skill4 1



##############################
#ダメージ計算
##############################

#体力検知
execute as @e[tag=boss] store result score @s hp run data get entity @s Health

#ダメージ量検知
execute as @e[tag=boss] run scoreboard players operation @s dead -= @s hp


#体力計算
execute as @e[tag=boss,scores={dead=1..}] run scoreboard players operation @s dummyhp -= @s dead
execute as @e[tag=boss,scores={dead=1..}] run data merge entity @s {Health:1024f}
scoreboard players set @e[tag=boss] dead 1024
execute as @e[tag=irumea,limit=1] store result bossbar suiryu:boss value run scoreboard players get @s dummyhp
execute as @e[tag=irumea,limit=1,scores={dummyhp=..0}] run data merge entity @s {NoAI:0b,HandItems:[{id:"minecraft:bow",Count:1b,tag:{Enchantments:[{id:"minecraft:power",lvl:10}]}},{id:"minecraft:tipped_arrow",Count:1b,tag:{CustomPotionEffects:[{Id:15b,Amplifier:0b,Duration:600}],CustomPotionColor:13092807}}],HandDropChances:[-327.67F,-327.67F],ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{display:{color:855309}}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:855309}}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:855309}}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"180b75b1-7d65-4c13-91f9-f26dddfe587d",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvZDlmNzFhM2Q1NTRhYzY3Nzk4NjE1NTc2NWUwMTk1N2QzZjExMWQxMDNiODNhZTY4MDkyMTZjZDI0YzI4In19fQ=="}]}}}}],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F]}
execute as @e[tag=irumea,limit=1,scores={dummyhp=..0}] run bossbar set suiryu:boss visible false
execute as @e[tag=boss,scores={dummyhp=..0}] run scoreboard players remove #stageman skill2 1
execute as @e[tag=boss,scores={dummyhp=..0}] run effect clear @s minecraft:invisibility
execute as @e[tag=boss,scores={dummyhp=..0}] run kill @s



##############################
#行動
##############################

#近づくとテレポート
execute as @e[tag=irumea,limit=1,tag=!tp] positioned as @s if entity @a[tag=player,distance=..2] run scoreboard players set @s skill1 100

#5秒毎にテレポート
execute as @e[tag=irumea,limit=1,tag=!skill,scores={skill1=100..}] run tag @s add tp
execute as @e[tag=tp,limit=1] run function suiryu_ordeal:stage/19/tp

#20秒毎にライトスペクション
execute as @e[tag=irumea,limit=1,tag=!skill,scores={skill2=400..}] run tag @s add lights
execute as @e[tag=lights,limit=1] run function suiryu_ordeal:stage/19/lights

#40秒毎にライトフィールド
execute as @e[tag=irumea,limit=1,tag=!skill,scores={skill3=800..}] run tag @s add lightf
execute as @e[tag=lightf,limit=1] run function suiryu_ordeal:stage/19/lightf

#100秒毎/体力475にライトメア=スペクタクル
execute as @e[tag=irumea,limit=1,tag=!skill,scores={skill4=2000..}] run tag @s add lightm
execute as @e[tag=irumea,limit=1,tag=!skill,tag=!hp475,scores={dummyhp=..475}] run tag @s add lighth
execute as @e[tag=lightm,limit=1] run function suiryu_ordeal:stage/19/lightm
execute as @e[tag=lighth,limit=1] run function suiryu_ordeal:stage/19/lighth

