##############################
#第四の試練メイン実行
##############################

#初期準備
execute if score #setman stage matches 0 run function suiryu_ordeal:stage/4/first

#スコア増加
scoreboard players add @e[tag=sefiru,limit=1] skill1 1
scoreboard players add @e[tag=sefiru,limit=1] skill2 1
scoreboard players add @e[tag=sefiru,limit=1] skill3 1
scoreboard players add @e[tag=sefiru,limit=1,scores={dummyhp=..200}] skill4 1
scoreboard players add @e[tag=sefiru,limit=1,scores={dummyhp=..160}] skill5 1
scoreboard players add @e[tag=verudo,limit=1] skill1 1




##############################
#ダメージ計算
##############################

#体力検知
execute as @e[tag=boss] store result score @s hp run data get entity @s Health

#ダメージ量検知
execute as @e[tag=boss] run scoreboard players operation @s dead -= @s hp

#体力計算
execute as @e[tag=boss,scores={dead=1..}] run scoreboard players operation @s dummyhp -= @s dead
execute as @e[tag=boss,scores={dead=1..}] run data merge entity @s {Health:1024f}
scoreboard players set @e[tag=boss] dead 1024
execute as @e[tag=sefiru,limit=1] store result bossbar suiryu:boss value run scoreboard players get @s dummyhp
execute as @e[tag=esuta,limit=1] store result bossbar suiryu:boss1 value run scoreboard players get @s dummyhp
execute as @e[tag=verudo,limit=1] store result bossbar suiryu:boss2 value run scoreboard players get @s dummyhp
execute as @e[tag=sefiru,scores={dummyhp=..0}] run bossbar set suiryu:boss visible false
execute as @e[tag=esuta,scores={dummyhp=..0}] run bossbar set suiryu:boss1 visible false
execute as @e[tag=verudo,scores={dummyhp=..0}] run bossbar set suiryu:boss2 visible false
execute as @e[tag=boss,scores={dummyhp=..0}] run scoreboard players remove #stageman skill2 1
execute as @e[tag=sefiru,scores={dummyhp=..0}] run kill @e[tag=sefiruarmorstand]
execute as @e[tag=verudo,scores={dummyhp=..0}] run kill @e[tag=verudoarmorstand]
execute as @e[tag=sefiru,scores={dummyhp=..0}] run data merge entity @s {NoAI:0b,HandItems:[{id:"minecraft:iron_sword",Count:1b,tag:{display:{Name:"{\"text\":\"聖剣「雪世」\",\"color\":\"white\",\"italic\":false}"},AttributeModifiers:[{AttributeName:"generic.attackDamage",Name:"generic.attackDamage",Amount:12,Operation:0,UUIDLeast:399546,UUIDMost:741542,Slot:"mainhand"}]}},{}],HandDropChances:[-327.67F,0.85F],ArmorItems:[{id:"minecraft:iron_boots",Count:1b,tag:{AttributeModifiers:[{AttributeName:"generic.movementSpeed",Name:"generic.movementSpeed",Amount:0.15,Operation:1,UUIDLeast:761413,UUIDMost:602858,Slot:"feet"}]}},{id:"minecraft:iron_leggings",Count:1b},{id:"minecraft:iron_chestplate",Count:1b},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"96cd7a77-a342-4d1a-a1da-308da1a2f898",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvYzU2ZmIyMjA2ZjJjM2NlOWVjNzk5MmNmZjdmMDJlZjNkZmZlNTQzNGNjZGI5MDQ1N2ZiN2EyZGU4MGY2MjhhOSJ9fX0="}]}}}}],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F],Attributes:[{Name:generic.maxHealth,Base:1024},{Name:generic.followRange,Base:50},{Name:generic.armor,Base:30}]}
execute as @e[tag=verudo,scores={dummyhp=..0}] run data merge entity @s {NoAI:0b,HandItems:[{id:"minecraft:ender_pearl",Count:1b,tag:{Enchantments:[{id:"minecraft:knockback",lvl:100}]}},{id:"minecraft:written_book",Count:1b,tag:{title:"",author:""}}],HandDropChances:[-327.67F,-327.67F],ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{display:{color:11221248},AttributeModifiers:[{AttributeName:"generic.movementSpeed",Name:"generic.movementSpeed",Amount:-0.2,Operation:1,UUIDLeast:967816,UUIDMost:746714,Slot:"feet"}]}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:9539985}}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:16777215}}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"8d33674e-5cb5-4a30-a8b5-5b3b8f3e174b",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvYTdlODlkYzNlZmFjMWIxMjY5NmMwYzg5YTM0ZGY0ZTFjMzM5NDM1Mjg3ZjY2N2M3ZGM4ZGQzNGM3Yzc4N2YifX19"}]}}}}],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F]}
execute as @e[tag=boss,scores={dummyhp=..0}] run effect clear @s minecraft:invisibility
execute as @e[tag=boss,scores={dummyhp=..0}] run kill @s



##############################
#行動
##############################


#20秒毎にセイントスレイ
execute as @e[tag=sefiru,limit=1,tag=!skill,tag=!saint,scores={skill1=400..},nbt={OnGround:1b}] run tag @s add saint
execute as @e[tag=saint,limit=1] run function suiryu_ordeal:stage/4/saint


#10秒後、その後20秒毎にセイントスレイ
execute as @e[tag=sefiru,limit=1,tag=!skill,tag=!saint2,scores={skill2=400..},nbt={OnGround:1b}] run tag @s add saint2
execute as @e[tag=saint2,limit=1] run function suiryu_ordeal:stage/4/saint2

#50秒毎、体力320/240/160で聖真神斬
execute as @e[tag=sefiru,limit=1,tag=!skill,tag=!saint2,scores={skill3=1000..},nbt={OnGround:1b}] run tag @s add god
execute as @e[tag=sefiru,limit=1,tag=!hp320,tag=!skill,tag=!god,scores={dummyhp=..320},nbt={OnGround:1b}] run tag @s add godhp
execute as @e[tag=sefiru,limit=1,tag=!hp240,tag=hp320,tag=!skill,tag=!god,scores={dummyhp=..240},nbt={OnGround:1b}] run tag @s add godhp
execute as @e[tag=sefiru,limit=1,tag=!hp160,tag=hp240,tag=!skill,tag=!god,scores={dummyhp=..160},nbt={OnGround:1b}] run tag @s add godhp
execute as @e[tag=sefiru,limit=1,tag=!hp320,tag=!skill,tag=!god,scores={dummyhp=..320},nbt={OnGround:1b}] run tag @s add god
execute as @e[tag=sefiru,limit=1,tag=!hp240,tag=hp320,tag=!skill,tag=!god,scores={dummyhp=..240},nbt={OnGround:1b}] run tag @s add god
execute as @e[tag=sefiru,limit=1,tag=!hp160,tag=hp240,tag=!skill,tag=!god,scores={dummyhp=..160},nbt={OnGround:1b}] run tag @s add god
execute as @e[tag=god,limit=1] run function suiryu_ordeal:stage/4/god

#体力300でエスタ、ヴェルド召喚

execute as @e[tag=sefiru,limit=1,tag=!hp300,tag=!skill,tag=!summon,scores={dummyhp=..300},nbt={OnGround:1b}] run tag @s add summon
execute as @e[tag=summon,limit=1] run function suiryu_ordeal:stage/4/summon

#体力200以下で10秒毎に〇〇スレイ
execute as @e[tag=sefiru,limit=1,tag=!skill,tag=!saint3,scores={skill4=200..},nbt={OnGround:1b}] run tag @s add saint3
execute as @e[tag=saint3,limit=1] run function suiryu_ordeal:stage/4/saint3

#体力160で聖輝の神髄
execute as @e[tag=sefiru,limit=1,tag=!sp160,tag=!skill,tag=!attackup,scores={dummyhp=..160},nbt={OnGround:1b}] run tag @s add attackup
execute as @e[tag=attackup,limit=1] run function suiryu_ordeal:stage/4/attackup

#体力160以下で30秒毎に聖輝真神斬
execute as @e[tag=sefiru,limit=1,tag=!skill,tag=!godt,scores={skill5=600..},nbt={OnGround:1b}] run tag @s add godt
execute as @e[tag=godt,limit=1] run function suiryu_ordeal:stage/4/godt

#体力80でセイクリッドロスト
execute as @e[tag=sefiru,limit=1,tag=!hp80,tag=!skill,tag=!ubb,scores={dummyhp=..80},nbt={OnGround:1b}] run tag @s add ubb
execute as @e[tag=ubb,limit=1] run function suiryu_ordeal:stage/4/ubb





##############################
#ヴェルド
##############################

#50秒毎に聖戦の大号令
execute as @e[tag=verudo,limit=1,tag=!skill,tag=!gourei,scores={skill1=1000..},nbt={OnGround:1b}] run tag @s add gourei
execute as @e[tag=gourei,limit=1] run function suiryu_ordeal:stage/4/gourei

#体力60/40で神の謀略
execute as @e[tag=verudo,limit=1,tag=!skill,tag=!hp60,tag=!bouryaku,scores={dummyhp=..60},nbt={OnGround:1b}] run tag @s add bouryaku
execute as @e[tag=verudo,limit=1,tag=!skill,tag=hp60,tag=!hp40,tag=!bouryaku,scores={dummyhp=..40},nbt={OnGround:1b}] run tag @s add bouryaku
execute as @e[tag=bouryaku,limit=1] run function suiryu_ordeal:stage/4/bouryaku



