##############################
#第五の試練メイン実行
##############################

#初期準備
execute if score #setman stage matches 0 run function suiryu_ordeal:stage/5/first

#スコア増加
scoreboard players add @e[tag=reira,limit=1] skill1 1
scoreboard players add @e[tag=reira,limit=1] skill2 1
scoreboard players add @e[tag=reira,limit=1] skill3 1
scoreboard players add @e[tag=reira,limit=1] skill4 1


#リレイズエフェクト
execute positioned as @e[tag=reraise,limit=1] run particle minecraft:instant_effect ~ ~2 ~ 0 0 0 0 1 force


##############################
#ダメージ計算
##############################

#体力検知
execute as @e[tag=boss] store result score @s hp run data get entity @s Health

#ダメージ量検知
execute as @e[tag=boss] run scoreboard players operation @s dead -= @s hp

#体力計算
execute as @e[tag=boss,scores={dead=1..}] run scoreboard players operation @s dummyhp -= @s dead
execute as @e[tag=boss,scores={dead=1..}] run data merge entity @s {Health:1024f}
scoreboard players set @e[tag=boss] dead 1024
execute as @e[tag=boss,limit=1] store result bossbar suiryu:boss value run scoreboard players get @s dummyhp
execute as @e[tag=boss,tag=reraise,scores={dummyhp=..0}] positioned as @s run function suiryu_ordeal:stage/5/reraise
execute as @e[tag=boss,tag=!reraise,scores={dummyhp=..0}] run bossbar set suiryu:boss visible false
execute as @e[tag=boss,tag=!reraise,scores={dummyhp=..0}] run scoreboard players remove #stageman skill2 1
execute as @e[tag=boss,tag=!reraise,scores={dummyhp=..0}] run data merge entity @s {NoAI:0b,ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{display:{color:0}}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:11579568}}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:16777215}}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"670e5416-9533-4ec1-8ded-c51aebd7b535",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvZWNhZGNlZjBkYWE4YWRjMWJjZDgzNWYyZDgxZWZiY2JmMjhlZWFiZDhkNWQyZWIzNWRmM2JlOGFhYzQ0YjE0YiJ9fX0="}]}}}}],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F]}
execute as @e[tag=boss,tag=!reraise,scores={dummyhp=..0}] run effect clear @s minecraft:invisibility
execute as @e[tag=boss,tag=!reraise,scores={dummyhp=..0}] run kill @s





##############################
#行動
##############################


#40秒毎にセイクリッドソング、セイクリッドボイス
execute as @e[tag=reira,limit=1,tag=!skill,tag=!song,scores={skill1=800..},nbt={OnGround:1b}] run tag @s add song
execute as @e[tag=song,limit=1] run function suiryu_ordeal:stage/5/song

#50秒毎にデッドリーボイス
execute as @e[tag=reira,limit=1,tag=!skill,tag=!voice,scores={skill2=1000..},nbt={OnGround:1b}] run tag @s add voice
execute as @e[tag=voice,limit=1] run function suiryu_ordeal:stage/5/voice

#体力300、その後は10秒毎にフォルテ
execute as @e[tag=reira,limit=1,tag=!hp300,tag=!skill,tag=!for,scores={dummyhp=..300},nbt={OnGround:1b}] run tag @s add for
execute as @e[tag=reira,limit=1,tag=hp300,tag=!skill,tag=!for,scores={skill4=200..},nbt={OnGround:1b}] run tag @s add for
execute as @e[tag=for,limit=1] run function suiryu_ordeal:stage/5/for

#体力250、その後は10秒毎にクレシェンド
execute as @e[tag=reira,limit=1,tag=!hp250,tag=!skill,tag=!kure,scores={dummyhp=..250},nbt={OnGround:1b}] run tag @s add kure
execute as @e[tag=reira,limit=1,tag=hp250,tag=!skill,tag=!kure,scores={skill3=200..},nbt={OnGround:1b}] run tag @s add kure
execute as @e[tag=kure,limit=1] run function suiryu_ordeal:stage/5/kure

#体力100でエンドレスソング
execute as @e[tag=reira,limit=1,tag=!hp100,tag=!skill,tag=!endless,scores={dummyhp=..100},nbt={OnGround:1b}] run tag @s add endless
execute as @e[tag=endless,limit=1] run function suiryu_ordeal:stage/5/endless


