##############################
#第七の試練メイン実行
##############################

#初期準備
execute if score #setman stage matches 0 run function suiryu_ordeal:stage/7/first

#スコア増加
scoreboard players add @e[tag=ngzk46,limit=1] skill1 1
scoreboard players add @e[tag=repair0,limit=1] skill2 1
scoreboard players add @e[tag=ngzk46,limit=1] skill3 1
scoreboard players add @e[tag=ngzk46,limit=1] skill5 1
scoreboard players add @e[tag=hp140,limit=1] skill8 1


#リレイズエフェクト
execute positioned as @e[tag=reraise,limit=1] run particle minecraft:instant_effect ~ ~2 ~ 0 0 0 0 1 force



##############################
#ダメージ計算
##############################

#体力検知
execute as @e[tag=boss] store result score @s hp run data get entity @s Health

#ダメージ量検知
execute as @e[tag=boss] run scoreboard players operation @s dead -= @s hp
execute as @e[tag=boss,tag=!break] run scoreboard players operation @s skill4 += @s dead
execute as @e[tag=boss,tag=!recover] run scoreboard players operation @s skill6 += @s dead
execute as @e[tag=boss,tag=hp140,tag=!pulse] run scoreboard players operation @s skill7 += @s dead


#体力計算
execute as @e[tag=boss,scores={dead=1..}] run scoreboard players operation @s dummyhp -= @s dead
execute as @e[tag=boss,scores={dead=1..}] run data merge entity @s {Health:1024f}
scoreboard players set @e[tag=boss] dead 1024
execute as @e[tag=boss,limit=1] store result bossbar suiryu:boss value run scoreboard players get @s dummyhp
execute as @e[tag=boss,tag=reraise,scores={dummyhp=..0}] positioned as @s run function suiryu_ordeal:stage/7/reraise
execute as @e[tag=boss,tag=!reraise,scores={dummyhp=..0}] run bossbar set suiryu:boss visible false
execute as @e[tag=boss,tag=!reraise,scores={dummyhp=..0}] run scoreboard players remove #stageman skill2 1
execute as @e[tag=boss,tag=!reraise,scores={dummyhp=..0}] run kill @e[tag=ngzk460]
execute as @e[tag=boss,tag=!reraise,scores={dummyhp=..0}] run kill @s



##############################
#タレット
##############################

execute as @e[tag=ngzk460] positioned as @s run effect give @a[tag=player,distance=..1] minecraft:instant_damage 1 0
execute as @e[tag=ngzk46,limit=1] at @s run tp @e[tag=ngzk461,limit=1] ^1.5 ^1 ^ ~ ~
execute as @e[tag=ngzk46,limit=1] at @s run tp @e[tag=ngzk462,limit=1] ^-1.5 ^1 ^ ~ ~
execute as @e[tag=ngzk46,limit=1] at @s run tp @e[tag=ngzk463,limit=1] ^1 ^0.5 ^ ~ ~
execute as @e[tag=ngzk46,limit=1] at @s run tp @e[tag=ngzk464,limit=1] ^-1 ^0.5 ^ ~ ~
execute as @e[tag=ngzk46,limit=1] at @s run tp @e[tag=ngzk465,limit=1] ^1 ^1.5 ^-0.5 ~ ~
execute as @e[tag=ngzk46,limit=1] at @s run tp @e[tag=ngzk466,limit=1] ^-1 ^1.5 ^-0.5 ~ ~



##############################
#行動
##############################

#40秒毎にREPAIR PROGRAM
execute as @e[tag=ngzk46,limit=1,tag=!skill,tag=!repair,scores={skill1=800..},nbt={OnGround:1b}] run tag @s add repair
execute as @e[tag=repair,limit=1] run function suiryu_ordeal:stage/7/repair
execute as @e[tag=repair0,limit=1,scores={skill2=200}] run scoreboard players add @s dummyhp 20
execute as @e[tag=repair0,limit=1,scores={skill2=200,dummyhp=701..}] run scoreboard players set @s dummyhp 700
execute as @e[tag=repair0,limit=1,scores={skill2=400}] run scoreboard players add @s dummyhp 20
execute as @e[tag=repair0,limit=1,scores={skill2=400,dummyhp=701..}] run scoreboard players set @s dummyhp 700
execute as @e[tag=repair0,limit=1,scores={skill2=600}] run scoreboard players add @s dummyhp 20
execute as @e[tag=repair0,limit=1,scores={skill2=600,dummyhp=701..}] run scoreboard players set @s dummyhp 700
execute as @e[tag=repair0,limit=1,scores={skill2=600}] run tag @s remove repair0

#50秒毎にγ-CODE
execute as @e[tag=ngzk46,limit=1,tag=!skill,tag=!ganma,scores={skill3=1000..},nbt={OnGround:1b}] run tag @s add ganma
execute as @e[tag=ganma,limit=1] run function suiryu_ordeal:stage/7/ganma

#被ダメ100毎にBREAK-CODE
execute as @e[tag=ngzk46,limit=1,tag=!skill,tag=!break,scores={skill4=100..},nbt={OnGround:1b}] run tag @s add break
execute as @e[tag=break,limit=1] run function suiryu_ordeal:stage/7/break

#60秒毎にELIMINATE-CODE
execute as @e[tag=ngzk46,limit=1,tag=!skill,tag=!ganma,scores={skill5=1200..},nbt={OnGround:1b}] run tag @s add eliminate
execute as @e[tag=eliminate,limit=1] run function suiryu_ordeal:stage/7/eliminate

#被ダメ200毎にRECOVERY-CODE
execute as @e[tag=ngzk46,limit=1,tag=!skill,tag=!recover,scores={skill6=200..},nbt={OnGround:1b}] run tag @s add recover
execute as @e[tag=recover,limit=1] run function suiryu_ordeal:stage/7/recover

#体力525/350/175でLOST-CODE
execute as @e[tag=ngzk46,limit=1,tag=!hp525,tag=!skill,tag=!lost,scores={dummyhp=..525},nbt={OnGround:1b}] run tag @s add lost
execute as @e[tag=ngzk46,limit=1,tag=!hp350,tag=hp525,tag=!skill,tag=!lost,scores={dummyhp=..350},nbt={OnGround:1b}] run tag @s add lost
execute as @e[tag=ngzk46,limit=1,tag=!hp175,tag=hp350,tag=!skill,tag=!lost,scores={dummyhp=..175},nbt={OnGround:1b}] run tag @s add lost
execute as @e[tag=lost,limit=1] run function suiryu_ordeal:stage/7/lost

#体力490/280でULTIMATE-CODE
execute as @e[tag=ngzk46,limit=1,tag=!hp490,tag=!skill,tag=!ultimate,scores={dummyhp=..490},nbt={OnGround:1b}] run tag @s add ultimate
execute as @e[tag=ngzk46,limit=1,tag=!hp280,tag=hp490,tag=!skill,tag=!ultimate,scores={dummyhp=..280},nbt={OnGround:1b}] run tag @s add ultimate
execute as @e[tag=ultimate,limit=1] run function suiryu_ordeal:stage/7/ultimate

#体力140でLIMITER RELEASE、その10秒後にULTIMATE-CODEΣ
execute as @e[tag=ngzk46,limit=1,tag=!hp140,tag=!skill,tag=!limit,scores={dummyhp=..140},nbt={OnGround:1b}] run tag @s add limit
execute as @e[tag=limit,limit=1] run function suiryu_ordeal:stage/7/limit
execute as @e[tag=limitoff,limit=1] positioned as @s run particle minecraft:dust 1 1 0 0.3 ~ ~1 ~ 0.1 0.5 0.1 1 30 force

#体力140以下で被ダメ30毎にBREAK-PULSE
execute as @e[tag=ngzk46,limit=1,tag=!skill,tag=!pulse,scores={skill7=30..},nbt={OnGround:1b}] run tag @s add pulse
execute as @e[tag=pulse,limit=1] run function suiryu_ordeal:stage/7/pulse

#体力140以下で60秒毎にGALAXY-CODE
execute as @e[tag=ngzk46,limit=1,tag=!skill,tag=!galaxy,scores={skill8=1200..},nbt={OnGround:1b}] run tag @s add galaxy
execute as @e[tag=galaxy,limit=1] run function suiryu_ordeal:stage/7/galaxy


