##############################
#第九の試練メイン実行
##############################

#初期準備
execute if score #setman stage matches 0 run function suiryu_ordeal:stage/9/first

#スコア増加
scoreboard players add @e[tag=merarudo,limit=1] skill1 1
scoreboard players add @e[tag=boss2] skill1 1
scoreboard players add @e[tag=merarudo,limit=1,tag=!merarudo2] skill3 1
scoreboard players add @e[tag=merarudo,limit=1,tag=!merarudo2] skill4 1
scoreboard players add @e[tag=merarudo,limit=1] skill5 1
scoreboard players add @e[tag=merarudo,limit=1] skill6 1
scoreboard players add @e[tag=heal,limit=1] skill8 1





##############################
#ダメージ計算
##############################

#体力検知
execute as @e[tag=boss] store result score @s hp run data get entity @s Health

#ダメージ量検知
execute as @e[tag=boss] run scoreboard players operation @s dead -= @s hp
execute as @e[tag=merarudo,tag=!merarudo2] run scoreboard players operation @s skill2 += @s dead


#体力計算
execute as @e[tag=boss,scores={dead=1..}] run scoreboard players operation @s dummyhp -= @s dead
execute as @e[tag=boss,scores={dead=1..}] run data merge entity @s {Health:1024f}
scoreboard players set @e[tag=boss,limit=1] dead 1024
execute as @e[tag=boss] store result bossbar suiryu:boss value run scoreboard players get @s dummyhp
execute as @e[tag=merarudo3,scores={dummyhp=..0}] run scoreboard players remove #stageman skill2 1
execute as @e[tag=merarudo3,scores={dummyhp=..0}] run data merge entity @s {NoAI:0b,ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{display:{color:1127168}}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:612608}}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:414720}}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"e81892cb-91a8-4d68-85c0-3e524539a04a",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvYWZlNmU5YjcxN2I3YmQxZTUwZDdmYmYwOWZiYTliN2RjZWIzYjBhNjU3ZjIxYzQzMjIxNzFiMWI1NDIifX19"}]}}}}],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F]}
execute as @e[tag=merarudo3,scores={dummyhp=..0}] run effect clear @s minecraft:invisibility
execute as @e[tag=merarudo3,scores={dummyhp=..0}] run kill @s



##############################
#第一段階+第三段階
##############################

#40秒毎に崩世牙
execute as @e[tag=merarudo,tag=!merarudo2,limit=1,tag=!skill,tag=!kiba,scores={skill4=800..},nbt={OnGround:1b}] run tag @s add kiba
execute as @e[tag=kiba,limit=1] run function suiryu_ordeal:stage/9/kiba

#40秒毎にカースワールド
execute as @e[tag=merarudo,limit=1,tag=!skill,tag=!curseworld,scores={skill1=800..},nbt={OnGround:1b}] run tag @s add curseworld
execute as @e[tag=curseworld,limit=1] run function suiryu_ordeal:stage/9/curseworld
execute positioned as @e[tag=boss2] run particle minecraft:witch ~ ~ ~ 0 0 0 0 10 force
kill @e[tag=boss2,scores={skill1=400..}]

#被ダメ100毎に精神統一
execute as @e[tag=merarudo,limit=1,tag=!skill,tag=!merarudo2,scores={skill2=100..},nbt={OnGround:1b}] run function suiryu_ordeal:stage/9/seisin

#第一段階では体力450でパワーイレーサー
#第三段階では50秒毎にパワーイレーサー
execute as @e[tag=merarudo1,limit=1,tag=!skill,tag=!hp450,tag=!erase,scores={dummyhp=..450},nbt={OnGround:1b}] run tag @s add erase
execute as @e[tag=merarudo3,limit=1,tag=!skill,tag=!erase,scores={skill5=1000..},nbt={OnGround:1b}] run tag @s add erase
execute as @e[tag=erase,limit=1] run function suiryu_ordeal:stage/9/erase

#60秒毎にカースライト
execute as @e[tag=merarudo,tag=!merarudo2,limit=1,tag=!skill,tag=!light,scores={skill3=1200..},nbt={OnGround:1b}] run tag @s add light
execute as @e[tag=light,limit=1] run function suiryu_ordeal:stage/9/light

#体力180でカースエンドレス
#第三段階ではその後40秒毎にカースエンドレス
execute as @e[tag=merarudo,tag=!merarudo2,limit=1,tag=!skill,tag=!hp180,tag=!ubb,scores={dummyhp=..180},nbt={OnGround:1b}] run tag @s add ubb
execute as @e[tag=merarudo3,tag=hp180,limit=1,tag=!skill,tag=!ubb,scores={skill6=800..},nbt={OnGround:1b}] run tag @s add ubb
execute as @e[tag=ubb,limit=1] run function suiryu_ordeal:stage/9/ubb

#体力0で第二段階
execute as @e[tag=merarudo1,limit=1,tag=!skill,scores={dummyhp=..0}] run tag @s add 2nd
execute as @e[tag=2nd,limit=1,tag=merarudo1] run function suiryu_ordeal:stage/9/2nd

##############################
#第二段階
##############################

#体力720/450でブラッディカース
execute as @e[tag=merarudo2,limit=1,tag=!skill,tag=!sp720,tag=!blood,scores={dummyhp=..720},nbt={OnGround:1b}] run tag @s add blood
execute as @e[tag=merarudo2,limit=1,tag=!skill,tag=sp720,tag=!sp450,tag=!blood,scores={dummyhp=..450},nbt={OnGround:1b}] run tag @s add blood
execute as @e[tag=blood,limit=1] run function suiryu_ordeal:stage/9/blood

#体力0で第三段階
execute as @e[tag=merarudo2,limit=1,tag=!skill,scores={dummyhp=..0}] run tag @s add 3rd
execute as @e[tag=3rd,limit=1,tag=merarudo2] run function suiryu_ordeal:stage/9/3rd

##############################
#第三段階
##############################

#カースエンドレスの10秒後にカースヒール
execute as @e[tag=heal,limit=1,tag=!skill,scores={skill8=200..},nbt={OnGround:1b}] run function suiryu_ordeal:stage/9/heal

