##############################
#騎士の試練メイン実行
##############################

#初期準備
execute if score #setman stage matches 0 run function suiryu_ordeal:stage/17/first

#スコア増加
scoreboard players add @e[tag=fasado,limit=1] skill1 1
scoreboard players remove @e[tag=fasado,limit=1,scores={skill2=1..}] skill2 1
scoreboard players add @e[tag=fasado,limit=1] skill3 1
scoreboard players add @e[tag=fasado,limit=1] skill4 1



##############################
#ダメージ計算
##############################

#体力検知
execute as @e[tag=boss] store result score @s hp run data get entity @s Health

#ダメージ量検知
execute as @e[tag=boss] run scoreboard players operation @s dead -= @s hp
execute as @e[tag=fasado,limit=1,scores={dead=1..}] run scoreboard players operation @s dead -= @s healthboost
execute as @e[tag=fasado,scores={dead=..-1},tag=!blackf] run scoreboard players operation @s hasteboost -= @s dead

#体力計算
execute as @e[tag=boss,scores={dead=1..}] run scoreboard players operation @s dummyhp -= @s dead
execute as @e[tag=fasado,scores={dead=..-1}] run scoreboard players operation @s dummyhp -= @s dead
execute as @e[tag=fasado,limit=1,scores={dummyhp=1701..}] run scoreboard players set @s dummyhp 1700
execute as @e[tag=boss,scores={dead=1..}] run data merge entity @s {Health:1024f}
execute as @e[tag=fasado,scores={dead=..-1}] run data merge entity @s {Health:1024f}
scoreboard players set @e[tag=boss] dead 1024
execute as @e[tag=fasado,limit=1] store result bossbar suiryu:boss value run scoreboard players get @s dummyhp
execute as @e[tag=fasado,limit=1,scores={dummyhp=..0}] run data merge entity @s {NoAI:0b,HandItems:[{id:"minecraft:iron_sword",Count:1b,tag:{Enchantments:[{id:"minecraft:knockback",lvl:1}]}},{id:"minecraft:shield",Count:1b,tag:{BlockEntityTag:{Base:0,Patterns:[{Pattern:gru,Color:15},{Pattern:gra,Color:15},{Pattern:flo,Color:0},{Pattern:sku,Color:7}]}}}],HandDropChances:[-327.67F,-327.67F],ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{display:{color:196608},AttributeModifiers:[{AttributeName:"generic.movementSpeed",Name:"generic.movementSpeed",Amount:0.2,Operation:1,UUIDLeast:311585,UUIDMost:609321,Slot:"feet"}]}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:851968}}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:983040}}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"0cb86983-870e-4456-b1ac-b0821ee8bcec",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvODBlYzlhM2FiYWVhZTg0Y2I0MmI4OWZhZGJmYTk3MzE5OGIyYjExZmZlNjBhYjMwMTU5MGQxODk5MmY2M2UifX19"}]}}}}],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F]}
execute as @e[tag=fasado,limit=1,scores={dummyhp=..0}] run bossbar set suiryu:boss visible false
execute as @e[tag=boss,scores={dummyhp=..0}] run scoreboard players remove #stageman skill2 1
execute as @e[tag=boss,scores={dummyhp=..0}] run effect clear @s minecraft:invisibility
execute as @e[tag=boss,scores={dummyhp=..0}] run kill @s



##############################
#行動
##############################

#10秒後、その後70秒毎に闇騎狂気
execute as @e[tag=fasado,limit=1,tag=!skill,scores={skill1=1400..},nbt={OnGround:1b}] run function suiryu_ordeal:stage/17/anki
execute as @e[tag=fasado,limit=1,scores={skill2=1..}] positioned as @a[tag=player] run particle minecraft:dust 1 1 1 0.5 ~ ~1 ~ 0.3 0.5 0.3 1 10 force
execute as @e[tag=fasado,limit=1,scores={skill2=1}] run function suiryu_ordeal:stage/17/anki0

#40秒毎にダークフェルテ
execute as @e[tag=fasado,limit=1,tag=!skill,tag=!darkf,scores={skill3=800..},nbt={OnGround:1b}] run tag @s add darkf
execute as @e[tag=darkf,limit=1] run function suiryu_ordeal:stage/17/darkf

#50秒毎に黒焉星撃
execute as @e[tag=fasado,limit=1,tag=!skill,tag=!darkf,scores={skill4=1000..},nbt={OnGround:1b}] run tag @s add blacke
execute as @e[tag=blacke,limit=1] run function suiryu_ordeal:stage/17/blacke
scoreboard players remove @e[tag=boss1,limit=1,scores={attackboost=1..}] attackboost 1
tag @e[tag=boss1,limit=1,scores={attackboost=0}] remove boss1

#ダメージ吸収量50毎にブラックフェール
execute as @e[tag=fasado,limit=1,tag=!skill,tag=!blackf,scores={hasteboost=50..},nbt={OnGround:1b}] run tag @s add blackf
execute as @e[tag=blackf,limit=1] run function suiryu_ordeal:stage/17/blackf

#体力850/340で冥星騎剣ジュードフォール
execute as @e[tag=fasado,limit=1,tag=!hp340,tag=!skill,tag=!ubb,scores={dummyhp=..340},nbt={OnGround:1b}] run tag @s add ubb
execute as @e[tag=fasado,limit=1,tag=!hp850,tag=!skill,tag=!ubb,scores={dummyhp=..850},nbt={OnGround:1b}] run tag @s add ubb
execute as @e[tag=ubb,limit=1] run function suiryu_ordeal:stage/17/ubb

#体力378で雷冥刻撃
execute as @e[tag=fasado,limit=1,tag=!hp378,tag=!skill,scores={dummyhp=..378},nbt={OnGround:1b}] run function suiryu_ordeal:stage/17/thunder


