##############################
#第二の試練メイン実行
##############################

#初期準備
execute if score #setman stage matches 0 run function suiryu_ordeal:stage/2/first

#スコア増加
scoreboard players add @e[tag=aika,limit=1] skill1 1
scoreboard players add @e[tag=aika,limit=1] skill2 1
scoreboard players add @e[tag=aika,limit=1] skill3 1
scoreboard players add @e[tag=aika,limit=1] skill4 1
scoreboard players add @e[tag=aika2,limit=1] skill5 1
scoreboard players add @e[tag=aika2,limit=1] skill6 1



##############################
#ダメージ計算
##############################

#体力検知
execute as @e[tag=boss] store result score @s hp run data get entity @s Health

#ダメージ量検知
execute as @e[tag=boss] run scoreboard players operation @s dead -= @s hp

#体力計算
execute as @e[tag=boss,scores={dead=1..}] run scoreboard players operation @s dummyhp -= @s dead
execute as @e[tag=boss,scores={dead=1..}] run data merge entity @s {Health:1024f}
scoreboard players set @e[tag=boss,limit=1] dead 1024
execute as @e[tag=boss] store result bossbar suiryu:boss value run scoreboard players get @s dummyhp
execute as @e[tag=boss,tag=aika2,scores={dummyhp=..0}] run scoreboard players remove #stageman skill2 1
execute as @e[tag=boss,tag=aika2,scores={dummyhp=..0}] run data merge entity @s {NoAI:0b,HandItems:[{id:"minecraft:diamond_sword",Count:1b,tag:{display:{Name:"{\"text\":\"凛剣アイヴィス\",\"color\":\"green\",\"italic\":false}",Lore:["§r攻撃時に斬り上げ"]}}},{}],HandDropChances:[-327.67F,0.85F],ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{display:{color:14247168},AttributeModifiers:[{AttributeName:"generic.movementSpeed",Name:"generic.movementSpeed",Amount:0.1,Operation:1,UUIDLeast:352062,UUIDMost:767305,Slot:"feet"}]}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:16777215}}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:4521728}}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"6961636c-12ea-4cae-8fa2-dff4c55de347",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvMjk0NjM2YjBhMWE3NjhkZDQ5YjFmNWZmMWJjMTczZGM4NzdjYzg1YjQyNmQ4YTYyM2QzMjZlNjhkYmRmMCJ9fX0="}]}}}}],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F]}
execute as @e[tag=boss,tag=aika2,scores={dummyhp=..0}] run effect clear @s minecraft:invisibility
execute as @e[tag=boss,tag=aika2,scores={dummyhp=..0}] run kill @s



##############################
#第一段階
##############################


#体力50以下で第二段階へ
execute as @e[tag=aika1,limit=1,tag=!skill,scores={dummyhp=..100}] run tag @s add 2nd
execute as @e[tag=2nd,limit=1,tag=aika1] run function suiryu_ordeal:stage/2/2nd



##############################
#第二段階
##############################

#20秒毎に瞬迅凛旋撃
execute as @e[tag=aika2,limit=1,tag=!skill,tag=!shun,scores={skill5=400..},nbt={OnGround:1b}] run tag @s add shun
execute as @e[tag=shun,limit=1] run function suiryu_ordeal:stage/2/shun

#30秒と50秒の倍数ではない20秒毎に旋迅舞
execute as @e[tag=aika2,limit=1,tag=!skill,tag=!mai,scores={skill6=400..},nbt={OnGround:1b}] run tag @s add mai
execute as @e[tag=mai,limit=1] run function suiryu_ordeal:stage/2/mai

#体力100/40で1度のみ精神統一、その10秒後凛剣「百花繚乱」
execute as @e[tag=aika2,limit=1,tag=!hp100,tag=!skill,tag=!ubb,scores={dummyhp=..100},nbt={OnGround:1b}] run tag @s add ubb
execute as @e[tag=aika2,limit=1,tag=!hp40,tag=hp100,tag=!skill,tag=!ubb,scores={dummyhp=..40},nbt={OnGround:1b}] run tag @s add ubb
execute as @e[tag=ubb,limit=1] run function suiryu_ordeal:stage/2/ubb
execute as @e[tag=ubb1] at @s run function suiryu_ordeal:stage/2/ubb0



##############################
#共通
##############################

#30秒毎に刹華嵐
execute as @e[tag=aika,limit=1,tag=!skill,tag=!arashi,scores={skill3=600..},nbt={OnGround:1b}] run tag @s add arashi
execute as @e[tag=arashi,limit=1] run function suiryu_ordeal:stage/2/arashi
execute as @e[tag=arashi1] at @s run function suiryu_ordeal:stage/2/arashi0

#20秒後・その後40秒毎に凛扇閃・椿
execute as @e[tag=aika,limit=1,tag=!skill,tag=!tsubaki,scores={skill1=800..},nbt={OnGround:1b}] run tag @s add tsubaki
execute as @e[tag=tsubaki,limit=1] run function suiryu_ordeal:stage/2/tsubaki

#40秒毎に凛扇閃・楓
execute as @e[tag=aika,limit=1,tag=!skill,tag=!kaede,scores={skill2=800..},nbt={OnGround:1b}] run tag @s add kaede
execute as @e[tag=kaede,limit=1] run function suiryu_ordeal:stage/2/kaede

#50秒毎に凛護陣
execute as @e[tag=aika,limit=1,tag=!skill,tag=!jin,scores={skill4=1000..},nbt={OnGround:1b}] run tag @s add jin
execute as @e[tag=jin,limit=1] run function suiryu_ordeal:stage/2/jin




