##############################
#武神の試練メイン実行
##############################

#初期準備
execute if score #setman stage matches 0 run function suiryu_ordeal:stage/20/first

#スコア増加
scoreboard players add @e[tag=shura,limit=1] skill1 1
scoreboard players add @e[tag=shura,limit=1] skill2 1
scoreboard players add @e[tag=shura,limit=1] skill3 1
scoreboard players add @e[tag=shura,limit=1,scores={dummyhp=..1000}] skill4 1
scoreboard players add @e[tag=shura,limit=1] skill5 1
scoreboard players add @e[tag=shura,limit=1] skill7 1




##############################
#ダメージ計算
##############################

#体力検知
execute as @e[tag=boss] store result score @s hp run data get entity @s Health

#ダメージ量検知
execute as @e[tag=boss] run scoreboard players operation @s dead -= @s hp
execute as @e[tag=shura,limit=1] run scoreboard players operation @s skill6 += @s dead

#体力計算
execute as @e[tag=boss,scores={dead=1..}] run scoreboard players operation @s dummyhp -= @s dead
execute as @e[tag=boss,scores={dead=1..}] run data merge entity @s {Health:1024f}
scoreboard players set @e[tag=boss] dead 1024
execute as @e[tag=shura,limit=1] store result bossbar suiryu:boss value run scoreboard players get @s dummyhp
execute as @e[tag=shura,limit=1,scores={dummyhp=..0}] run data merge entity @s {NoAI:0b,HandItems:[{id:"minecraft:iron_sword",Count:1b,tag:{display:{Name:"{\"text\":\"武神覇剣「雷炎」\",\"color\":\"red\",\"bold\":true,\"italic\":false}"},Unbreakable:1b,Enchantments:[{id:"minecraft:sharpness",lvl:1},{id:"minecraft:knockback",lvl:1},{id:"minecraft:fire_aspect",lvl:1},{id:"minecraft:sweeping",lvl:1}],AttributeModifiers:[{AttributeName:"generic.knockbackResistance",Name:"generic.knockbackResistance",Amount:0.3,Operation:1,UUIDLeast:760806,UUIDMost:968949,Slot:"mainhand"},{AttributeName:"generic.movementSpeed",Name:"generic.movementSpeed",Amount:-0.35,Operation:1,UUIDLeast:999270,UUIDMost:568807,Slot:"mainhand"},{AttributeName:"generic.attackDamage",Name:"generic.attackDamage",Amount:30,Operation:0,UUIDLeast:565470,UUIDMost:776720,Slot:"mainhand"},{AttributeName:"generic.armor",Name:"generic.armor",Amount:-0.15,Operation:1,UUIDLeast:745259,UUIDMost:69407,Slot:"mainhand"},{AttributeName:"generic.attackSpeed",Name:"generic.attackSpeed",Amount:-0.2,Operation:1,UUIDLeast:317603,UUIDMost:75026,Slot:"mainhand"}]}},{}],HandDropChances:[-327.67F,0.85F],ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{display:{color:11206656}}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:16711680}}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:16711680}}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"9f41b6f3-182a-489a-9a53-267b97f5b1be",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvYTRkNjYxZTE0YTQ4NjM2NWQ3OWZiMGNiZTdiYWQ1MjAzZDQ5YzBlY2RlZjBhMGFmMmM5MDFhOGVlMzI5In19fQ=="}]}}}}],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F]}
execute as @e[tag=shura,limit=1,scores={dummyhp=..0}] run bossbar set suiryu:boss visible false
execute as @e[tag=boss,scores={dummyhp=..0}] run scoreboard players remove #stageman skill2 1
execute as @e[tag=boss,scores={dummyhp=..0}] run effect clear @s minecraft:invisibility
execute as @e[tag=boss,scores={dummyhp=..0}] run kill @s

execute as @e[tag=shura,limit=1,tag=!hp1000,scores={dummyhp=..1000}] run tellraw @a ["",{"text":"["},{"text":"闘魔武神シュラ","color":"red"},{"text":"]やるなあ！血が滾って来たぜ！！！"}]
execute as @e[tag=shura,limit=1,tag=!hp1000,scores={dummyhp=..1000}] run tag @s add hp1000

##############################
#共通
##############################

#30秒毎に構え
execute as @e[tag=shura,limit=1,tag=!skill,scores={skill1=600..}] run function suiryu_ordeal:stage/20/kamae

#10秒毎に武神雷炎突
execute as @e[tag=shura,limit=1,tag=!skill,scores={skill2=200..},nbt={OnGround:1b}] run tag @s add totsu
execute as @e[tag=totsu,limit=1] run function suiryu_ordeal:stage/20/totsu

#10秒毎に武神雷炎振
execute as @e[tag=sin,limit=1] run function suiryu_ordeal:stage/20/sin

#25秒毎に武神雷炎波
execute as @e[tag=shura,limit=1,tag=!skill,scores={skill3=500..},nbt={OnGround:1b}] run tag @s add nami
execute as @e[tag=nami,limit=1] run function suiryu_ordeal:stage/20/nami

#体力1000以下で10秒毎に滅世真武雷炎斬
execute as @e[tag=shura,limit=1,tag=!skill,scores={skill4=200..},nbt={OnGround:1b}] run tag @s add metsu
execute as @e[tag=metsu,limit=1] run function suiryu_ordeal:stage/20/metsu

#オーラ
execute as @e[tag=aura,limit=1] positioned as @s run particle minecraft:dust -1 0 0 0.6 ~ ~1 ~ 0.3 0.5 0.3 0 10 force

##############################
#武の構え
##############################

#追撃
execute as @e[tag=bu,limit=1] positioned as @a[tag=player] run particle minecraft:dust 2 0 0 0.5 ~ ~1 ~ 0.3 0.5 0.3 1 30 force
execute as @e[tag=bu,limit=1,scores={skill1=180}] run effect give @a[tag=player] minecraft:instant_damage 1 4
execute as @e[tag=bu,limit=1,scores={skill1=360}] run effect give @a[tag=player] minecraft:instant_damage 1 4
execute as @e[tag=bu,limit=1,scores={skill1=540}] run effect give @a[tag=player] minecraft:instant_damage 1 4

#昇雷炎斬
execute as @e[tag=30s,limit=1,tag=!skill,nbt={OnGround:1b}] at @s rotated ~ 0 positioned ^ ^ ^1.5 if entity @a[tag=player,distance=..1] run tag @s add shou
execute as @e[tag=shou,limit=1] run function suiryu_ordeal:stage/20/shou

#昇雷炎旋斬
execute as @e[tag=bu,limit=1,tag=!skill,nbt={OnGround:1b}] unless entity @a[tag=player,distance=..15] run tag @s add shousen
execute as @e[tag=shousen,limit=1] run function suiryu_ordeal:stage/20/shousen

#絶魂終滅斬
execute if entity @a[tag=player,scores={jump=5..},limit=1] as @e[tag=bu,limit=1,tag=!skill,nbt={OnGround:1b}] run tag @s add zetsu
execute as @e[tag=zetsu,limit=1] run function suiryu_ordeal:stage/20/zetsu

#オーラ
execute as @e[tag=shura,limit=1,scores={skill1=200}] run tag @s remove aura
execute as @e[tag=shura,limit=1,scores={skill1=400}] run tag @s remove aura
execute as @e[tag=shura,limit=1,scores={skill1=599}] run tag @s remove aura
execute as @e[tag=bu,limit=1,scores={skill1=200,skill6=60..}] run tag @s add aura
execute as @e[tag=bu,limit=1,scores={skill1=400,skill6=60..}] run tag @s add aura
execute as @e[tag=bu,limit=1,scores={skill1=599,skill6=60..}] run tag @s add aura

#滅界封神斬
execute as @e[tag=bu,tag=aura,limit=1,tag=!skill,scores={skill6=1..9},nbt={OnGround:1b}] run tag @s add fusin

##############################
#覇の構え
##############################

#滅神雷炎連斬
execute if entity @a[tag=player,scores={jump=1..},limit=1] as @e[tag=ha,limit=1,tag=!skill,nbt={OnGround:1b}] run tag @s add ren
execute as @e[tag=ren,limit=1] run function suiryu_ordeal:stage/20/ren

#14秒毎に滅界怒雷炎波
execute as @e[tag=ha,limit=1,tag=!skill,scores={skill7=280..},nbt={OnGround:1b}] run tag @s add onami
execute as @e[tag=onami,limit=1] run function suiryu_ordeal:stage/20/onami

#オーラ
execute as @e[tag=ha,limit=1,scores={skill1=200,skill6=..59}] run tag @s add aura
execute as @e[tag=ha,limit=1,scores={skill1=400,skill6=..59}] run tag @s add aura
execute as @e[tag=ha,limit=1,scores={skill1=599,skill6=..59}] run tag @s add aura

#滅界封神斬
execute as @e[tag=ha,tag=aura,limit=1,tag=!skill,scores={skill6=60..},nbt={OnGround:1b}] run tag @s add fusin

##############################
#神の構え
##############################

#12秒毎に武神雷波斬
execute as @e[tag=kami,limit=1,tag=!skill,scores={skill7=240..},nbt={OnGround:1b}] run tag @s add raiha
execute as @e[tag=raiha,limit=1] run function suiryu_ordeal:stage/20/raiha

#煉獄雷炎波
execute if entity @a[tag=player,scores={jump=3..},limit=1] as @e[tag=kami,limit=1,tag=!skill,nbt={OnGround:1b}] run tag @s add rengoku
execute as @e[tag=rengoku,limit=1] run function suiryu_ordeal:stage/20/rengoku

#オーラ
execute as @e[tag=kami,limit=1,scores={skill1=200,skill6=..49}] run tag @s add aura
execute as @e[tag=kami,limit=1,scores={skill1=400,skill6=..49}] run tag @s add aura
execute as @e[tag=kami,limit=1,scores={skill1=599,skill6=..49}] run tag @s add aura

#滅界封神斬
execute as @e[tag=kami,tag=aura,limit=1,tag=!skill,scores={skill6=60..},nbt={OnGround:1b}] run tag @s add fusin
execute as @e[tag=fusin,limit=1] run function suiryu_ordeal:stage/20/fusin

execute as @e[tag=shura,limit=1,scores={skill1=200}] run scoreboard players set @s skill6 0
execute as @e[tag=shura,limit=1,scores={skill1=400}] run scoreboard players set @s skill6 0
execute as @e[tag=shura,limit=1,scores={skill1=599}] run scoreboard players set @s skill6 0

