##############################
#第六の試練メイン実行
##############################

#初期準備
execute if score #setman stage matches 0 run function suiryu_ordeal:stage/6/first

#スコア増加
scoreboard players add @e[tag=rikuru,limit=1] skill1 1
scoreboard players add @e[tag=rikuru,limit=1] skill2 1
scoreboard players add @e[tag=killedaun,limit=1] skill3 1
scoreboard players add @e[tag=un,limit=1] skill1 1




##############################
#ダメージ計算
##############################

#体力検知
execute as @e[tag=boss] store result score @s hp run data get entity @s Health

#ダメージ量検知
execute as @e[tag=boss] run scoreboard players operation @s dead -= @s hp

#体力計算
execute as @e[tag=boss,scores={dead=1..}] run scoreboard players operation @s dummyhp -= @s dead
execute as @e[tag=boss,scores={dead=1..}] run data merge entity @s {Health:1024f}
scoreboard players set @e[tag=boss] dead 1024
execute as @e[tag=rikuru,limit=1] store result bossbar suiryu:boss value run scoreboard players get @s dummyhp
execute as @e[tag=a,limit=1] store result bossbar suiryu:boss1 value run scoreboard players get @s dummyhp
execute as @e[tag=un,limit=1] store result bossbar suiryu:boss2 value run scoreboard players get @s dummyhp
execute as @e[tag=rikuru,scores={dummyhp=..0}] run bossbar set suiryu:boss visible false
execute as @e[tag=a,scores={dummyhp=..0}] run bossbar set suiryu:boss1 visible false
execute as @e[tag=un,scores={dummyhp=..0}] run bossbar set suiryu:boss2 visible false
execute as @e[tag=boss,scores={dummyhp=..0}] run scoreboard players remove #stageman skill2 1
execute as @e[tag=rikuru,scores={dummyhp=..0}] run kill @e[tag=rikuruarmorstand]
execute as @e[tag=un,scores={dummyhp=..0}] run kill @e[tag=unarmorstand]
execute as @e[tag=rikuru,scores={dummyhp=..0}] run data merge entity @s {NoAI:0b,ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{display:{color:10263708}}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:16777215}}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:65527}}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"3f7e8ac9-ebeb-45d9-97bb-c029b8148598",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvYTIzYjhhNWQ0N2ZmMjlmZTE3MTgzYzk0YmZkZjI4NTRlZmNhMjJiNTk3MDA3OTcyZmQ2YzQ3MWI3YTFmNzllYyJ9fX0="}]}}}}],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F]}
execute as @e[tag=un,scores={dummyhp=..0}] run data merge entity @s {NoAI:0b,ArmorItems:[{id:"minecraft:leather_boots",Count:1b,tag:{display:{color:16777215},AttributeModifiers:[{AttributeName:"generic.movementSpeed",Name:"generic.movementSpeed",Amount:-0.3,Operation:1,UUIDLeast:257952,UUIDMost:204117,Slot:"feet"}]}},{id:"minecraft:leather_leggings",Count:1b,tag:{display:{color:4585983}}},{id:"minecraft:leather_chestplate",Count:1b,tag:{display:{color:16777215}}},{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:"e7ba20e4-49d4-457b-9dfd-e97f0d8f51a1",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvMzg0MTU2NDEyMDk3NGEyYTczNGRlZDAxNjhmZjlmZTU3NzkxYzU5ZDYxYTE1M2VhMTI2MTU5Yjk1Y2VkYmU5MSJ9fX0="}]}}}}],ArmorDropChances:[-327.67F,-327.67F,-327.67F,-327.67F]}
execute as @e[tag=boss,scores={dummyhp=..0}] run effect clear @s minecraft:invisibility
execute as @e[tag=boss,scores={dummyhp=..0}] run kill @s





##############################
#リクル
##############################

#30秒毎に癒神の激怒
execute as @e[tag=rikuru,limit=1,tag=!skill,tag=!angry,scores={skill1=600..},nbt={OnGround:1b}] run tag @s add angry
execute as @e[tag=angry,limit=1] run function suiryu_ordeal:stage/6/angry

#40秒毎にカースブライド
execute as @e[tag=rikuru,limit=1,tag=!skill,tag=!curse,scores={skill2=800..},nbt={OnGround:1b}] run tag @s add curse
execute as @e[tag=curse,limit=1] run function suiryu_ordeal:stage/6/curse

#体力420/300で癒光
execute as @e[tag=rikuru,limit=1,tag=!hp420,tag=!skill,tag=!light,scores={dummyhp=..420},nbt={OnGround:1b}] run tag @s add light
execute as @e[tag=rikuru,limit=1,tag=!hp300,tag=hp420,tag=!skill,tag=!light,scores={dummyhp=..300},nbt={OnGround:1b}] run tag @s add light
execute as @e[tag=light,limit=1] run function suiryu_ordeal:stage/6/light

#体力420/300/180/120/阿吽をどちらか倒した時に癒神の激昂
execute as @e[tag=rikuru,limit=1,tag=!sp420,tag=!skill,tag=!angry2,scores={dummyhp=..420},nbt={OnGround:1b}] run tag @s add angry2
execute as @e[tag=rikuru,limit=1,tag=!sp300,tag=sp420,tag=!skill,tag=!angry2,scores={dummyhp=..300},nbt={OnGround:1b}] run tag @s add angry2
execute as @e[tag=rikuru,limit=1,tag=!sp180,tag=sp300,tag=!skill,tag=!angry2,scores={dummyhp=..180},nbt={OnGround:1b}] run tag @s add angry2
execute as @e[tag=rikuru,limit=1,tag=!sp120,tag=sp180,tag=!skill,tag=!angry2,scores={dummyhp=..120},nbt={OnGround:1b}] run tag @s add angry2
execute unless entity @e[tag=a,limit=1] as @e[tag=rikuru,limit=1,tag=!killedaun,tag=!skill,tag=!angry2,nbt={OnGround:1b}] run tag @s add angry2
execute unless entity @e[tag=a,limit=1] as @e[tag=rikuru,limit=1,tag=!killedaun,tag=!skill,tag=angry2,nbt={OnGround:1b}] run tag @s add killedaun
execute unless entity @e[tag=un,limit=1] as @e[tag=rikuru,limit=1,tag=!killedaun,tag=!skill,tag=!angry2,nbt={OnGround:1b}] run tag @s add angry2
execute unless entity @e[tag=un,limit=1] as @e[tag=rikuru,limit=1,tag=!killedaun,tag=!skill,tag=angry2,nbt={OnGround:1b}] run tag @s add killedaun
execute as @e[tag=angry2,limit=1] run function suiryu_ordeal:stage/6/angry2

#体力120でエンドレスカース
execute as @e[tag=rikuru,limit=1,tag=!hp120,tag=!skill,tag=!ubb,scores={dummyhp=..120},nbt={OnGround:1b}] run tag @s add ubb
execute as @e[tag=ubb,limit=1] run function suiryu_ordeal:stage/6/endless

#10秒後/阿吽どちらかを倒してから70秒後
execute as @e[tag=rikuru,limit=1,tag=!skill,tag=!summon,scores={skill3=1400..},nbt={OnGround:1b}] run tag @s add summon
execute as @e[tag=summon,limit=1] run function suiryu_ordeal:stage/6/summon


##############################
#吽帝
##############################

#30秒毎に聖なる加護
execute as @e[tag=un,limit=1,tag=!skill,tag=!unbb,scores={skill1=600..},nbt={OnGround:1b}] run tag @s add unbb
execute as @e[tag=unbb,limit=1] run function suiryu_ordeal:stage/6/unbb









